
print macro string
	lea	dx,string
	mov	ah,9
	int	21h
	endm
getcm	macro
	push	es
	les	bx,ds:[curr_buff]
	mov	al,es:[bx]
	inc	word ptr ds:[curr_buff]
	xor	ah,ah
	pop	es
	endm

cseg segment para public 'CODE'
	org	100h
assume	cs:cseg,ds:cseg,ss:cseg

entry: jmp	start
;
;
lz_tree	equ 1128h
crc_table	equ 1328h
text_buf	equ 1528h
curr_buff	equ 2528h
lh_head	equ 252Ch
lh_name	equ 2542h
r	equ 2552h
crc_store	equ 2554h
crc_temp	equ 2556h
work_word	equ 2558h
data_start	equ 255Ah
bit_count	equ 255Bh
buffersize	equ 8000h
;
;
;
hello	db	"AXL, Adam's LHARC Extractor version 1.0, Copyright 1989 by Adam Selene.",13,10
	db	"Based on code by YOSHI Copyright 1989.",13,10,10
	db	"AXL may be distributed pursuant to the following conditions:",13,10
	db	" 1) No fee of any kind is received for AXL or disks contining AXL.",13,10
	db	" 2) AXL is distributed without modification in any way.",13,10,10,'$'
err6	db	07,'Memory Allocation Error',13,10,'$'
err1	db	07,'Command line error',13,10,'$'
err2	db	07,'Error opening file',13,10,'$'
istack	equ this byte
err3	db	07,'Error Creating file',13,10,'$'
err4	db	07,'Unrecoverable read error',13,10,'$'
err5	db	07,'Write error (disk full?)',13,10,'$'
err7	db	07,'Error reading LHARC file header',13,10,'$'
overwok	db	' Exists. Overwrite [Y/N] $'
crlf	db	13,10,'$'

file_count	dw	-1	; how many file_specs to check

file_list	dw 	8 dup(0)
handlei dw	0
infile	db	65 dup(0)
target	dw	0
builder	db	65 dup(0)
handleo	dw	0
;	the followng is the work area
buffer	equ this dword
buffer_loc	dw	0
buffer_seg	dw	0
;	the followng is the work area
work_area equ this dword
work_loc	dw	0
work_seg	dw	0
;
last_bytes	db	0
bufferbytes	dw	0	; how many bytes left in buffer
curr_head_len	dw	0	; used by head checking routines
;
;
work_byte	db 0,'$'
L12B	db	1,4,0ch,18h,'0'
write_e	db	'Write$'
crc_e	db	'CRC'
errorp	db	' Error',13,10,'$'
;
; keep these guys together
switches db '!APRTV'
switchcount equ	6
bswitch db 0	; bang switch
aswitch db 0	; autolharc switch
pswitch db 0	; print switch
rswitch db 0	; replace switch
tswitch db 0	; test integrity only
vswitch db 0	; verbose switch
;
;
;
start:
	print hello
	call	parse
	jc	do_error
	call	check_files
	call	open_in
	jc	do_error
	lea	sp,istack-2
	call	memory_alloc
	jc	do_error
	call	get_buff ; fill up buffer
	jc	do_error
	cmp	ax,0
	je	do_error
	call	lharc_code
	mov	ax,4C00h
	int	21h
do_error:
	mov	ah,9
	int	21h
	mov	ax,4C01h
	int	21h
;
;
create_target:
; this procedure first checks to see if the	header matches anyone
; on out list and the it creates the work area with a target
	push	bx
	push	dx
	push	si
	push	di
	push	ds
	push	es
;
;	es:[askldjasj] points to current working file
;
	push	es
	pop	ds
	push	cs
	pop	es	; current segment is the target
; step 1) see if guy is on list
	mov	bx,0	; the file_list
	cmp	cs:file_count,0
	jg	do_one_by_one
	jmp	do_em_all
do_one_by_one:
	mov	cx,cs:file_count
	mov	bx,-2
; here we have to check each guy in the file list
comp_loop:
	push	cx
	mov	dx,0	; if period encountered
	inc	bx
	inc	bx
	mov	di,es:file_list[bx]
	mov	si,lh_name	; header, file name
	mov	cl,ds:[si-01h]
	mov	ch,00h
comp_head_1:
	lodsb
	call	upper
	mov	ah,al
	mov	al,byte ptr es:[di]
	call	upper
	inc	di
	cmp	al,ah
	je	c_h_1
	cmp	al,'*'
	je	got_a_star1
	cmp	al,'?'
	jne	no_match1
c_h_1:
	cmp	al,'.'
	je	comp_head_2
	loop	comp_head_1
	jmp	got_a_guy
got_a_star1:
; ah is from the lharc, al is from command.line
	mov	al,es:[di]
	inc	di
	cmp	al,'*'
	je	got_a_star1
	cmp	al,0
	je	got_a_guy
	cmp	al,'.'
	jne	got_a_star1
; have the . in al now have to get a . in ah
look_dot1:
	cmp	ah,'.'
	je	comp_head_2
	mov	ah,ds:[si]
	inc	si
	xchg	al,ah
	call	upper
	xchg	al,ah
	loop	look_dot1
	jmp	got_a_guy
comp_head_2:
	dec	cx
	cmp	cx,0
	je	got_a_guy
comp_head_3:
; at this point there is a . in both al and ah
	lodsb
	call	upper
	mov	ah,al
	mov	al,byte ptr es:[di]
	call	upper
	inc	di
	cmp	al,ah
	je	c_h_2
	cmp	al,'?'
	je	c_h_2
	cmp	al,'*'
	je	got_a_guy
	jmp	no_match
no_match1:
	pop	cx
	loop	comp_loop
	jmp	c_h_3
c_h_2:
	loop	comp_head_3
	jmp	got_a_guy
c_h_3:
	push	cx
; if we get here, there is no match
no_match:
	pop	cx
	jmp	no_target
got_a_guy:
	pop	cx
do_em_all:
; if we are here, we are matched to the list, now create the
; target expression
;	es is currently the cs segment
	push	ds
	push	cs
	pop	ds
	lea	di,builder
	mov	si,target
	cmp	si,0
	je	no_target1
dem1:
	lodsb
	cmp	al,0
	je	no_target1
	stosb
	jmp	dem1
no_target1:
	pop	ds
	mov	si,lh_name	; header, file name
	mov	cl,ds:[si-01h]
	mov	ch,00h
rep	movsb
	mov	al,'$'
	stosb
	dec	si
; print file name
	push	ds
	push	cs
	pop	ds
	lea	dx,builder
	mov	ah,09h
	int	21h
	mov	al,0
	stosb
	print	crlf
;
; check to see if the file exists
	cmp	cs:rswitch,1
	je	file_not_found
	cmp	cs:pswitch,1
	je	file_not_found
	mov	ax,4300h	; state the file
	lea	dx,builder
	int	21h
	jb	file_not_found
	print	overwok
ask_yn:
	mov	ah,08h	; read a character
	int	21h
	and	al,0DFh	; make upper case
	cmp	al,'Y'
	je	is_y
	cmp	al,'N'
	jne	ask_yn
is_y:
	mov	work_byte,al
	push	ax
	print	work_byte
	print	crlf
	pop	ax
	cmp	al,'N'
	je	no_target_a
file_not_found:
; file exitst
	mov	ax,1
	cmp	pswitch,1
	je	good_create
	lea	dx,builder
	mov	cl,20h ; Unarchived attribute
	mov	ah,3Ch ; create a file
	int	21h
	jnb	good_create
	call	close_file
	call	delete_file
	mov	dx,offset err5
	mov	ax,2
	pop	ds
	pop	es
	pop	ds
	pop	di
	pop	si
	pop	dx
	pop	bx
	stc
	ret
good_create:
	mov	cs:handleo,ax
	xor	ax,ax
	pop	ds
	mov	ds:[crc_temp],ax
	mov	ds:[r],ax
exit_target:
	pop	es
	pop	ds
	pop	di
	pop	si
	pop	dx
	pop	bx
	clc
	ret
no_target_a:
	pop	ds
no_target:
	mov	ax,1
	pop	es
	pop	ds
	pop	di
	pop	si
	pop	dx
	pop	bx
	stc
	ret

upper:
	cmp	al,'a'
	jl	is_up
	cmp	al,'z'
	jg	is_up
	sub	al,32
is_up:
	ret
get_next_buff:
; dx:ax has the amount of stuff to move down
	cmp	cs:last_bytes,1
	jne	gnb0
	add	ds:[curr_buff],ax
	clc
	ret
gnb0:
	mov	ds,cs:work_seg
	cmp	ds:[curr_buff],buffersize/2
	jl	gnb3 ; don't bother to move down if there's 16k left
gnb0a:
	lds	si,ds:[curr_buff]; ds:si points to where we are getting bytes
	push	ds
	pop	es
; move down existing stuff
	sub	cs:bufferbytes,si; total read into buffer
	mov	cx,cs:bufferbytes	; total read move down
	mov	di,0
	cld
rep movsb
	push	ax
	push	dx
	mov	dx,di
	mov	cx,buffersize
	sub	cx,di	; whats left to fill
; refresh the buffer
	mov	dx,di
	mov	ah,3fh
	mov	bx,cs:handlei
	int	21h
	jnc	gnb1
	pop	dx
	pop	ax
	lea	dx,err4
	stc
	ret
gnb1:
	add	cs:bufferbytes,ax
	cmp	ax,cx
	je	gnb2
	mov	cs:last_bytes,1
gnb2:
	push	ds
	mov	ds,cs:work_seg
	mov	ax,cs:buffer_seg
	mov	ds:[curr_buff+2],ax
	mov	word ptr ds:[curr_buff],0
	pop	ds
	pop	dx
	pop	ax
gnb3:
; dx:ax has the amount we wish to bypass
	cmp	cs:last_bytes,1
	jne	do_skip0
	add	ds:[curr_buff],ax
	mov	ax,0
	cwd
	clc
	ret
do_skip0:
	cmp	dx,0
	jne	do_skip
	cmp	ax,0
	je	no_skip

do_skip:
; have to skip over the data
; ds segment is set to work_area
; drop down in 32k chunks
;
	mov	ds,cs:work_seg
	cmp	word ptr ds:[curr_buff],0
	je	do_skipa
	jmp	gnb0a
do_skipa:
	sub	ax,7fffh
	sbb	dx,0
	cmp	dx,0
	jge	full_move
	add	ax,7fffh
	mov	word ptr ds:[curr_buff],ax
	mov	ax,0
	cwd
	clc
	ret
full_move:
	mov	word ptr ds:[curr_buff],7fffh
	call	get_next_buff
no_skip:
	clc
	ret


get_buff:
; gets a buffer full of stuff and initializes counters
	push	ds
	push	es
	mov	ds,cs:buffer_seg
	mov	cs:buffer_loc,0
	mov	cs:last_bytes,0
	mov	cs:bufferbytes,0
	mov	cx,buffersize
	mov	dx,0
	mov	ax,0
	call	gb0
	pop	es
	pop	ds
	ret
gb0:
	mov	ah,3fh
	mov	bx,cs:handlei
	int	21h
	jnc	gb1
	lea	dx,err4
	stc
	ret
gb1:
	add	cs:bufferbytes,ax
	cmp	ax,cx
	je	gb2
	mov	cs:last_bytes,1
gb2:
	mov	ds,cs:work_seg
	mov	ax,cs:buffer_seg
	mov	ds:[curr_buff+2],ax
	mov	word ptr ds:[curr_buff],0
	clc
	ret
;lh_head struc
;head_len	db 0	; length of header
;checksum	db 0	; checksum of header (not counting length
;comp_type	db '-1h0-' ; 1h0 = none, 1h1 = lharc
;comp_size	dd 0	;7	2533
;uncomp_size	dd 0	;b	2537
;file_time	dw 0	;f	253b
;file_date	dw 0	;11	253d
;file_attrib	dw 0	;13	253f
;file_name_len	db 0	;15	2541
;file_name	db ?	;16	2542
;crc_16	dw 0
;header_len	dw 0	; used instead of crc-16 sometimes
;lh_head	ends
;
;
head_work:
	push	ds
	lds	si,ds:[curr_buff] ; address of next file to work on
	mov	cl,ds:[si]
	or	cl,cl
	jnz	cont_head
	mov	ax,2
	pop	ds
	clc
	ret
cont_head:
	xor	ch,ch
	mov	cs:curr_head_len,cx
	push	cx
	mov	di,lh_head	; header
	lodsw	
	stosw	
	xor	al,al
head_check_loop:
	add	al,ds:[si]
	movsb	
	loop	head_check_loop
	pop	cx
	pop	ds
	mov	ds:[curr_buff],si
	cmp	al,ah
	jz	good_head
bad_header:
	mov	dx,offset err7
	stc
	ret
good_head:
	mov	ax,ds:[di-02h]	; last byte of guy
	mov	ds:[crc_store],ax
	mov	bx,lh_name	; header, file name
	mov	dx,bx
	add	bl,ds:[bx-01h]
	adc	bh,00h
	sub	di,bx
	mov	ds:[data_start],di ; start of data
	mov	di,252Eh
	cmp	word ptr ds:[di],6C2Dh
	jnz	bad_header
	mov	ax,ds:[di+02h]
	xchg	al,ah
	sub	ax,6830h
	mov	bp,ax	; file size
	cmp	ax,1
	ja	bad_header
	cmp	byte ptr ds:[di+04h],2Dh
	jnz	bad_header
; first thing to d is create the target header
	call	create_target
	jnc	no_bypass
	cmp	ax,2
	je	bad_bypass
	jmp	bypass
bad_bypass:
	stc
	ret
no_bypass:
	mov	ax,0
	clc
	ret
bypass:
	mov	ax,ds:[2533h]
	mov	dx,ds:[2535h]
	call	L384
	mov	ax,1
	clc
	ret
;
;
;
lharc_code:
; main entry to decode the lharc
	mov	ax,work_seg
	mov	ds,ax
	mov	es,ax
; set up area for CRC
	mov	di,crc_table
	xor	dx,dx
crc_top:
	mov	ax,dx
	mov	cx,8
crc_bit_loop:
	shr	ax,1
	jnb	no_xor
	xor	ax,0A001h
no_xor:
	loop	crc_bit_loop
	stosw	
	inc	dl
	jnz	crc_top
; done crc, now set up default tree
	mov	si,offset L12B
	mov	di,lz_tree	; tree location
	mov	ax,1
	mov	dx,0020h
fill_tree_loop:	
	cmp	ah,cs:[si]
	jnz	ah_not_0
	inc	al
	inc	si
	shr	dx,1
ah_not_0:
	mov	cx,dx
fill_tree:
	mov	ds:[di+0100h],ah
	stosb	
	loop	fill_tree
	inc	ah
	cmp	ah,40h
	jl	fill_tree_loop
	mov	ax,cs:buffer_seg
	mov	ds:[curr_buff+2],ax	; start of data
	mov	word ptr ds:[curr_buff],0 ; offset of first header
	jmp	check_more_files
more_files:
; cl has the length of the header, si is pointing at the data area
	call	head_work
; on return from head_work, stc is a bad head
; ax = 1 is bypass head, 0 = good head
	jnc	good_head_work
	ret
good_head_work:
 	cmp	ax,1
	je	check_more_files
	cmp	ax,2
	je	done_files
	or	bp,bp	; bp carries the remainder to do
	jz	L2A5
	call	L553
	jmp	short	L2A8
L2A5:
	call	L3A5
L2A8:
	sub	byte ptr ds:[bit_count],8
	jl	L2B5
	dec	word ptr ds:[curr_buff]
	jmp	L2A8
L2B5:
	call	L381
	mov	dx,ds:[253Dh]
	mov	cx,ds:[253Bh]
	mov	bx,cs:handleo
	mov	ax,5701h	; touch with date and time
	int	21h
	call	close_file
	cmp	byte ptr ds:[data_start],2
	jnz	check_more_files
 	mov	ax,ds:[crc_temp]
 	cmp	ax,ds:[crc_store]
 	jnz	crc_error_exit
	mov	bx,offset crlf
	call	print_dos
check_more_files:
	jmp	more_files
done_files:
	push	cs
	pop	es
	mov	bx,31h
	mov	ah,4Ah	; shrink memory
	int	21h
	push	cs
	pop	ds
exit_clean:
	clc
	ret
crc_error_exit:
	call	delete_file
	mov	dx,offset crc_e
	jmp	short	error_exit
print_err:
	call	print_dos
	mov	dx,offset errorp
error_exit:
	stc
	ret
write_file:
	mov	dx,text_buf
	mov	cx,di
	mov	bx,ds:[r]
	add	dx,bx
	sub	cx,bx
	mov	bx,cs:handleo
	mov	ah,40h
	int	21h
	jnc	good_write
bad_write:
	lea	dx,err5
	stc
	ret
good_write:
	cmp	cs:pswitch,1
	je	no_ch_cx
	sub	ax,cx
	jnz	bad_write
no_ch_cx:
	mov	ds:[r],0
	push	si
	mov	si,dx
	jcxz	by_crc_loop
	mov	ax,ds:[crc_temp]
crc_calc_loop:
	xor	al,ds:[si]
	inc	si
	mov	bl,al
	xor	bh,bh
	mov	al,ah
	xor	ah,ah
	shl	bx,1h
	xor	ax,ds:[bx+crc_table]
	loop	crc_calc_loop
	mov	ds:[crc_temp],ax
by_crc_loop:
	call	L381
	pop	si
	clc
	cmp	cs:pswitch,1
	mov	ah,2	; prints the dot out
	mov	dl,'.'
	cmp	cs:pswitch,0
	je	dos_int
	clc
	ret
close_file:
	clc
	mov	bx,cs:handleo
	mov	ah,3Eh
	cmp	cs:pswitch,0
	je	dos_int
	clc
	ret
	jmp	short	dos_int
delete_file:
	clc
	mov	dx,lh_name	;	delete a file
	mov	ah,41h
	cmp	cs:pswitch,0
	je	dos_int
	clc
	ret
dos_int:
	int	21h
	ret	
;
;
;	the following code moves ahead a segment in the buffer
;
; we need to replace this with code that checks to see that we are
; less than a ke away from end of data and if so do the move down
; and refill routines
;
L381:
	xor	ax,ax
L383:
	CWD
L384:
; on entry dx:ax has either nothing or the amount the start of next file
; or ax has the current position in a file
;
; got it. this moves you to within 16 bytes of the start of a segment
; we can do the same thing by movin down
;
;
	push	si
	push	di
	push	ds
	push	es
; on entry curr_buff has the location for si
; ax has the amount to skip forward
	call	get_next_buff
;
	pop	es
	pop	ds
	pop	di
	pop	si
	ret
;
;
L3A5:
	xor	di,di
L3A7:
	mov	bx,2537h
	sub	ds:[bx],di
	sbb	word ptr ds:[bx+2],+00
	mov	cx,1000h
	jnz	L3C1
	mov	ax,ds:[bx]
	or	ax,ax
	jz	L3D8
	cmp	ax,cx
	jnb	L3C1
	mov	cx,ax
L3C1:
	push	cx
	mov	di,text_buf
	lds	si,ds:[curr_buff]
	repz	movsb
	push	es
	pop	ds
	pop	di
	call	write_file
	jc	L3D8
	mov	ax,di
	call	L383
	jmp	L3A7
L3D8:
	ret
print_dos:
	push	ds
	push	ax
	push	dx
	push	cs
	pop	ds
	mov	dx,bx
	mov	ah,09h
	int	21h
	pop	dx
	pop	ax
	pop	ds
	ret	
L3E8:
	push	si
	xor	si,si
	mov	di,si
L3ED:
	mov	bx,ds:[si+0C42h]
	lodsw	
	cmp	bx,bp
	jb	L3FE
	inc	ax
	shr	ax,1
	mov	ds:[di+0C42h],bx
	stosw	
L3FE:
	cmp	si,bp
	jb	L3ED
	xor	si,si
L404:
	push	si
	lodsw	
	add	ax,ds:[si]
	mov	ds:[di],ax
	mov	bx,di
L40C:
	dec	bx
	dec	bx
	cmp	ax,ds:[bx]
	jb	L40C
	inc	bx
	inc	bx
	push	ax
	push	di
	std	
	jmp	short	L425
L419:
	mov	ax,ds:[di-02h]
	mov	cx,ds:[di+0C40h]
	mov	ds:[di+0C42h],cx
	stosw	
L425:
	cmp	di,bx
	ja	L419
	cld	
	pop	di
	pop	ds:[bx]
	pop	ds:[bx+0C42h]
;	lodsw
;	scasw
	inc	si
	inc	si
	inc	di
	inc	di
	cmp	di,bp
	jb	L404
	xor	si,si
L439:
	mov	di,ds:[si+0C42h]
	mov	ds:[di+04E8h],si
	cmp	di,bp
	jnb	L449
	mov	ds:[di+04EAh],si
L449:
	lodsw
	cmp	si,bp
	jb	L439
	pop	si
	ret	
L450:
;	or	word ptr ds:[04E4h],+00
 	db 83h,0eh,0e4h,04h,00h
	jns	L45A
	call	L3E8
L45A:	
	mov	si,ds:[bp+si+04E8h]
L45F:
 	mov	di,si
;	mov	ax,ds:[di]
;	scasw
	lodsw
	xchg	si,di
	scasw	
	jnz	L495
	mov	cx,0FFFFh
	repz	scasw
	sub	di,+04h
	mov	bx,ds:[si+0C42h]
	mov	ds:[bx+04E8h],di
	cmp	bx,bp
	jnb	L47F
	mov	ds:[bx+04EAh],di
L47F:
	xchg	bx,ds:[di+0C42h]
	mov	ds:[bx+04E8h],si
	cmp	bx,bp
	jnb	L48F
	mov	ds:[bx+04EAh],si
L48F:
	mov	ds:[si+0C42h],bx
	mov	si,di
L495:
	inc	word ptr ds:[si]
	mov	si,ds:[si+04E8h]
	or	si,si
	jnz	L45F
	ret	
DecodeChar:
	push	bp
	mov	bp,04E6h
	mov	si,ds:[1126h]
	mov	dx,ds:[work_word]
	mov	cl,ds:[bit_count]
	xor	ch,ch
L4B2:
	jcxz	getw
L4B4:
	shr	si,1
	shl	dx,1
	adc	si,+00
	shl	si,1
	mov	si,ds:[si+0C42h]
	dec	cx
	cmp	si,bp
	jb	L4B2
	mov	ds:[work_word],dx
	mov	ds:[bit_count],cl
	sub	si,bp
	push	si
	call	L450
	pop	ax
	shr	ax,1
	pop	bp
	ret	
getw:
	push	es
	les	bx,ds:[curr_buff]
	mov	ax,es:[bx]
	add	word ptr ds:[curr_buff],2
	mov	dx,ax
	xchg	dh,dl
	pop	es
	mov	cl,10h
	jmp	L4B4
L4F7:
	push	cx
	mov	dx,ds:[work_word]
	cmp	byte ptr ds:[bit_count],08
	jg	L515
	getcm
	mov	cl,08
	sub	cl,ds:[bit_count]
	shl	ax,cl
	or	dx,ax
	add	byte ptr ds:[bit_count],08
L515:
	pop	cx
	mov	ax,dx
	shl	dx,cl
	mov	ds:[work_word],dx
	sub	ds:[bit_count],cl
	mov	dx,0FFFFh
	shr	dx,cl
	not	dx
	and	ax,dx
	ret	
L52C:
	mov	cx,0008
	call	L4F7
	xchg	al,ah
	mov	si,ax
	mov	dl,ds:[si+1228h]
	mov	dh,00
	mov	cl,06
	shl	dx,cl
	push	dx
	mov	cl,ds:[si+lz_tree]
	call	L4F7
	or	ax,si
	rol	ax,cl
	and	ax,003Fh
	pop	dx
	add	ax,dx
	ret	
L553:
; these are initialize the trees
	mov	si,2537h
	lodsw	
	or	ax,ds:[si]
	jnz	L55E
	jmp	L609
L55E:
	mov	ax,1
	mov	cx,13Ah
	push	cx
	xor	di,di
	repz	stosw
	mov	ax,04E6h
	xor	dx,dx
	pop	cx
	mov	di,0C42h
	mov	bx,09CEh
L575:
	stosw
	inc	ax
	inc	ax
	mov	ds:[bx],dx
	inc	bx
	inc	bx
	inc	dx
	inc	dx
	loop	L575
	xor	si,si
	mov	di,0274h
	mov	cx,139h
L588:
	mov	ds:[di+0C42h],si
	mov	ds:[si+04E8h],di
	lodsw	
	add	ax,ds:[si]
	mov	ds:[si+04E8h],di
	stosw	
;	lodsw
	inc	si
	inc	si
	loop	L588
	xor	ax,ax
	mov	ds:[work_word],ax
	mov	ds:[09CCh],ax
	dec	ax
	mov	ds:[di],ax
	mov	al,20h
	mov	cx,1000h
	mov	di,text_buf
	repz	stosb
	mov	di,0FC4h
	mov	ds:[r],di
	mov	bp,0FFFh
L5BA:
	push	di
	call	DecodeChar
	or	ah,ah
	jnz	L5C9
	pop	di
	mov	cx,0001
	push	cx
	jmp	short	L5E2
L5C9:
	push	ax
	call	L52C
	pop	cx
	pop	di
	mov	si,di
	sub	si,ax
	dec	si
	and	si,bp
	sub	cx,00FDh
	push	cx
L5DB:
	mov	al,ds:[si+text_buf]
	inc	si
	and	si,bp
L5E2:
	mov	ds:[di+text_buf],al
	inc	di
	cmp	di,bp
	jbe	L5F0
	push	cx
	call	write_file
	pop	cx
L5F0:
	and	di,bp
	loop	L5DB
	pop	cx
	mov	bx,2537h
	sub	ds:[bx],cx
	pushf	
	sbb	word ptr ds:[bx+02h],+00
	pop	ax
	lahf	
	and	ah,al
	sahf	
	jg	L5BA
	call	write_file
L609:
	ret
last_byte equ this byte
open_in:
	lea	dx,infile
	mov	ax,3d10h
	int	21h
	jc	open_error
	mov	handlei,ax
	clc
	ret
open_error:
	lea	dx,err2
	stc
	ret
parse:
; get switches
	mov	cl,byte ptr ds:[80h]
	mov	ch,0
	mov	di,81h
cont_switch:
	mov	al,'/'
	cld
repne	scasb
	jne	done_switches
	mov	si,di
	mov	byte ptr ds:[di-1],' '
	lodsb
	mov	byte ptr ds:[di],' '
	call	upper
	push	di
	lea	di,switches
	push	cx
	mov	cx,switchcount
	cld
repne scasb
	pop	cx
	jne	no_switch
	dec	di
	add	di,switchcount
	mov	byte ptr ds:[di],1
no_switch:
	pop	di
	cmp	cx,1
	jle	done_switches
	jmp	cont_switch
p_error:
	lea	dx,err1
	stc
	ret
done_switches:
; get file names
	mov	cl,byte ptr ds:[80h]
	mov	ch,0
	mov	si,81h
	lea	di,infile
	mov	bx,0
p1:
	lodsb
	dec	cx
	cmp	cx,0
	jl	p_error
	cmp	al,13
	je	p_error
	cmp	al,20h
	je	p1
	cmp	al,9
	je	p1
p2:
; convert to upper
	call	upper
	stosb
	lodsb
	cmp	al,'.'
	jne	p2a
	mov	bx,1
p2a:
	dec	cx
	cmp	cx,0
	jl	p3
	cmp	al,13
	je	p_error
	cmp	al,20h
	je	p3
	cmp	al,9
	jne	p2
p3:
	cmp	bx,0
	jne	p3a
	mov	ax,'L.'
	stosw
	mov	ax,'HZ'
	stosw
p3a:
	mov	al,0
	stosb
; start files
	lea	bx,file_list
p4:
	mov	dx,si
	lodsb
	dec	cx
	cmp	cx,0
	jl	p_exit
	cmp	al,13
	je	p_exit
	cmp	al,20h
	je	p4
	cmp	al,9
	je	p4
p5:
	lodsb
	dec	cx
	cmp	cx,0
	jl	p7
	cmp	al,13
	je	p7
	cmp	al,20h
	je	p6
	cmp	al,9
	jne	p5
p6:
	mov	al,0
	mov	byte ptr ds:[si-1],0
	cmp	cs:file_count,0
	jg	p6a
	mov	cs:file_count,0
p6a:
	inc	cs:file_count
	mov	word ptr ds:[bx],dx
	inc	bx
	inc	bx
	jmp	p4
p7:
	cmp	file_count,0
	jg	p7a
	mov	file_count,0
p7a:
	inc	file_count
	mov	word ptr ds:[bx],dx
	mov	al,0
	mov	byte ptr ds:[si-1],0
p_exit:
	mov	al,0
	mov	byte ptr ds:[si-1],0
	clc
	ret
memory_alloc:
; allocates memory
; shrink
;
	mov	ah,4ah
	lea	bx,last_byte
	add	bx,15
	shr	bx,1
	shr	bx,1
	shr	bx,1
	shr	bx,1
	int	21h
	jnc	good_shrink
bad_mem:
	lea dx,err6
	stc
	ret
good_shrink:
; allocate 64k buffer for file access
	mov	ah,48h
	mov	bx,800h ; 32k
	int	21h
	jc	bad_mem
	mov	buffer_seg,ax
	mov	buffer_loc,0
; allocate 64k buffer for work tables
	mov	ah,48h
	mov	bx,300h ; 12k
	int	21h
	jc	bad_mem
	mov	work_seg,ax
	mov	work_loc,0
	clc
	ret
;
;
check_files:
; this routine checks the file list to see if there should
; be an append guy.
	cmp	file_count,0
	jg	cont_cf
	ret
cont_cf:
; check the last guy
	mov	bx,file_count
	dec	bx
	shl	bx,1
	mov	si,file_list[bx]
	mov	di,si	; start of target
; we will use the : or \ for telling if its a file
	cld
cf_0:
	lodsb
	cmp	al,':'
	je	cf_1
	cmp	al,'\'
	je	cf_1
	cmp	al,13
	jne	cf_0
; it is not a target
	ret
cf_1:
; it is a target
	lodsb
	cmp	al,0
	jne	cf_1
	mov	target,di
	dec	file_count
	dec	si
	dec	si
	cmp	byte ptr ds:[si],':'
	je	cf_2
	cmp	byte ptr ds:[si],'\'
	je	cf_2
	inc	si
	mov	byte ptr ds:[si],'\'
	inc	si
	mov	byte ptr ds:[si],0
cf_2:
	ret
;
;
	
cseg ends
	end entry
