
#include <ctype.h>
#include <dos.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

FILE *bfile;

struct header {
     char hlen;
     char hsig[8];
     int  disknum;
     char hfill[127];
     char lastflag;
     }  hdr;

struct filerec {
     char filename[12];
     char fragment;
     long filesize;
     int  sequence;
     long backoff;
     long fragsize;
     char attrib;
     char ffill;
     int  ftime;
     int  fdate;
         }  frec;

struct dirrec {
     char dirname[63];
     int  dircount;
     long nextdir;
     }   drec;


char control_file[15]="A:\\control.*";

char drive;

int main(int argc, char *argv[])
{
      char l;
    if (argc > 1)
        {
        control_file[0]= toupper(*(argv[1]));
        drive= toupper(*(argv[1]));
        }
    else
        {
        control_file[0]= 'A';
        drive= 'A';
        }

    if (find_control_file(control_file) == -1)
    {
        printf("\nControl file not found on drive %c\n",drive);
        exit(1);
    }

    /* open control file for binary read-only & assign pointer to stream */
    if ((bfile = fopen(control_file,"rb")) == NULL)
    {
        printf("\nError opening %s\n",control_file);
        exit(1);
    }

    /* read in the first 139 bytes of the header */

    if(fread(&hdr,1,139,bfile)!=139)
	{
	  printf("\nCan't read control file %s\n",control_file);
	  exit(-1);
	}

    printf("\nContents of Backup disk %3d\n",hdr.disknum);

    /* starting with byte 139, read entries until end of file */
    l=0;
    while (l!=-1)
    {
        switch (l=fgetc(bfile))
        {
            case 0x22:      /* new file */
                file_entry();
                break;

            case 0x46:      /* new directory */

                dir_entry();
                break;
            case -1:
                break;
            default:
                printf("\nUnknown record type in control %d \n",l);
                break;
        }
    }
    fclose(bfile);
    return(0);
}

/****
*
*  Finds the first CONTROL file on the drive specified by first argument.
*  Assumes that fileptr points to a location with at least 15 bytes free.
*  returns with 0 if CONTROL file found, or -1 if no matches are found.
*
****/

int find_control_file (char *fileptr)
{
    int i;
    struct _find_t fileinfo;

    strcpy(&fileptr[11],"*");      /* default search string */

    /* didn't find match or found match w/o extension */
    if ((_dos_findfirst(fileptr,_A_NORMAL,&fileinfo) != 0)
      || (!(strpbrk(fileinfo.name,"."))))
        return(-1);

    /* update extension */
    for (i = 11; i <=13; i++)
	fileptr[i] = fileinfo.name[i-3];

    return(0);
}


int file_entry(void)
{
    char f[20];

    if(fread(&frec,1,33,bfile)!=33)
	{
	  printf("\nCan't read control file %s\n",control_file);
	  exit(-1);
	}

    /* copy buffer to file name */
    memcpy(f,frec.filename,12);
    f[12]=0;
    puts(f);
 }

int dir_entry(void)
{
    if(fread(&drec,1,69,bfile)!=69)
	{
	  printf("\nCan't read control file %s\n",control_file);
	  exit(-1);
	}

    /* copy buffer to file name */
    puts(drec.dirname);
 }

