cseg     SEGMENT PARA   PUBLIC  'CODE'
                ASSUME  CS:cseg,DS:cseg,SS:cseg,ES:cseg
                ORG     0h    ; Use 100h so we can run this through exe2bin
; Boot record is loaded in at 7c0:0 and executed. The data offsets
; are all in relation to DS = 0 so all offsets must be increased
; by 7C00
load_point      EQU     7C00h
; these equates allow a convenient way to refer to data in the record
;
location_of     EQU     load_point+offset
data_at EQU     load_point+
; This looks like it was written by someone used to writing COM files
; because he uses the technique of jumping over the data. Either
; that or he needed to have the DOS version near the front
enter:          JMP     main    ;skip over data
track_word      equ this word
track           equ this word+5
version  DB     'KPG  2.0'
bytes_per_sect  DW      200h
sect_per_clust  DB      2
reserv_sects    DW      1
fat_copies      DB      2
dir_entries     DW      70h
sects_on_disk   DW      02d0h
format_id        equ    this byte
sector          DB      0fdh
sect_per_fat    DW      2
sect_per_trk    equ     this byte
sec_per_trk_dw  DW      9
sides           DW      2
spec_res_sect   DW      0
head_drive      equ     this word
drive           DB      0
head            DB      0
max_sectors     DB      0ah
disk_params     DB      0dfh,2,25h,2,9,02ah,0ffh,050h,0f6h,0fh,02
re_boot:
                INT     19h     ; start boot over again
main            PROC    NEAR
; the POST system has been finished and the boot
; record is read into 0:7c00 the registers are still set from
; that read. the first thing it does is read again
        CLI     ; stop interrupts
        XOR     AX,AX   ; zero ax
        MOV     SS,AX   ; set stack at segment 0
        MOV     SP,location_of enter    ; set stack pointer to entry
; ok to interrupt
        STI
        MOV     DS,AX   ; set data segment to 0
; set up disk paramter table to be 0:7c21
        MOV     DS:[007ah],AX
        MOV     DS:[0078h],location_of disk_params
; get a sector. On entry the registers are set to get sector 0
        INT     13h        ; this re-reads sector 0
        JNB     sector_found
        JMP     boot_failure
sector_found:
        PUSH    CS
        POP     DS
        MOV     AL,data_at fat_copies   ; value 2
        CBW
        MUL     WORD PTR data_at sect_per_fat ; value 2
        ADD     AX,data_at spec_res_sect         ; value 0
        ADD     AX,data_at reserv_sects  ; value 0
        MOV     data_at track_word,AX    ; moves a 4 here number of fat
        MOV     data_at sects_on_disk,AX         ; sectors
        MOV     AX,0020h
        MUL     DS:[data_at dir_entries]        ; 70h (70h*20h)=0e00h
        ADD     AX,01ffh        ; gets you fffh
        MOV     BX,0200h
        DIV     BX              ; leaves you 7
        ADD     DS:[data_at sects_on_disk],AX   ; makes it 11
        CALL    check_sys       ; are ibmbio and ibmcom here?
        JB      re_boot  ; if not try again
        MOV     AX,DS:[data_at sects_on_disk]   ; set sector of ibmbio
        MOV     DS:[data_at sector_to_read],AX  ; save it
        MOV     AX,0070h        ; where ibmbio gets loaded
        MOV     ES,AX
        MOV     DS,AX
        MOV     BX,0000h        ; now read will go to 70:000
get_next_sector:
        MOV     AX,CS:[data_at sects_on_disk] ;sector number
        CALL    calc_sector_num ; calc track, etc
        MOV     AL,BYTE PTR CS:[data_at sect_per_trk] ;9 = # of sec
        SUB     AL,CS:[data_at sector] ; has an fd (-3) = 6
        INC     AL       ;7
        XOR     AH,AH
        PUSH    AX
        MOV     AH,02
        CALL    read_sector
        POP     AX
        JB      boot_failure
        SUB     CS:[data_at max_sectors],AL ; has an 0ah
        JBE     good_sect_count ; if we got less than 10 sectors
        ADD     CS:[data_at sects_on_disk],AX
        MUL     CS:[data_at bytes_per_sect]
        ADD     BX,AX
        JMP     get_next_sector
good_sect_count:
        PUSH    CS
        POP     DS
        INT     11h      ;equipment check
        ROL     AL,1
        ROL     AL,1
        AND     AX,0003h        ; get the number of drives
        JNZ     drive_count_ok
        INC     AX       ; fake the b: drive
drive_count_ok:
        INC     AX       ; bump up to get correct number
        MOV     CX,AX
        TEST    data_at drive,80h
        JNZ     jump_to_bio
        XOR     AX,AX
jump_to_bio:
        MOV     BX,DS:[data_at sector_to_read]
;               JMP     0070H:0000H     ; this jumps to ibmbio entry
        DB      0eah,0,0,70h,0  ;NO WAY TO ASSEMBLE ABOVE
boot_failure:
        MOV     SI,location_of boot_err_mess
        CALL    print_line
freeze:
        JMP     freeze  ; THIS FREEZES THINGS UP
print_line:
; THIS ROUTINE PRINTS A MESSAGE ON THE SCREEN
        LODS    BYTE PTR CS:[SI]
        AND     AL,7fh
        JZ      b_return
        MOV     AH,0eh
        MOV     BX,0007h
        INT     10h
        JMP     print_line
check_sys:      ; check for presence of ibmbio and ibmcom
        MOV     AX,0050h        ; segment for sector
        MOV     ES,AX
        PUSH    CS
        POP     DS
        MOV     AX,CS:[data_at track_word]      ; first dir entry
        CALL    calc_sector_num  ; calc actual track etc
        MOV     BX,0000h
        MOV     AX,0201h
        CALL    read_sector             ; get the dir
        JB      wait_key        ; did it work?
        XOR     DI,DI    ; set index to 0
        XOR     DI,DI           ; set first entry
        MOV     SI,location_of ibmbio   ; to be compared
        MOV     CX,000bh         ; compare 11
        CLD
REPZ     CMPSB          ; is it the same?
        JNZ     wait_key         ; if no escape
        MOV     DI,0020h
        MOV     SI,location_of ibmdos   ; now ibmdos turn
        MOV     CX,000bh
REPZ     CMPSB
        JNZ     wait_key
b_return:
        RET
wait_key:
;wait for a key stroke
        MOV     SI,location_of non_sys_mess
        CALL    print_line
        MOV     AH,00h
        INT     16h
        STC
        RET
calc_sector_num:
        PUSH    DS
        PUSH    CS
        POP     DS
        XOR     DX,DX
        DIV     DS:[data_at sec_per_trk_dw]
        INC     DL
        MOV     DS:[data_at sector],DL
        XOR     DX,DX
        DIV     WORD PTR DS:[data_at sides]
        MOV     DS:[data_at head],DL
        MOV     data_at track,AX
        POP     DS
        RET
read_sector:
        MOV     DX,CS:[data_at track]
        MOV     CL,06h
        SHL     DH,CL
        OR      DH,CS:[data_at sector]
        MOV     CX,DX
        XCHG    CH,CL
        MOV     DX,CS:[data_at head_drive]
        INT     13h
        RET
sector_to_read  DW      0
non_sys_mess DB 13,10
        DB      'This is a non-system disk',13,10
        DB      'Replace and strike any key when ready'
        DB      13,10,0
boot_err_mess DB        13,10
        DB      'Disk Boot failure',13,10,0
ibmbio  DB      'IBMBIO  COM0'
ibmdos  DB      'IBMDOS  COM0'
        DB      0,0,0,0,0,0,0
        DB      55h,0aah
main     ENDP
cseg     ENDS
        END     enter
