; this is the electronic catalog program
;
print macro string
	lea	dx,string
	mov	ah,9
	int	21h
	endm
int10h macro
local faster,slower
	cmp	cs:fast,1
	jne	slower
	call	do_int10h
	jmp	short faster
slower:
	int 10h
faster:
endm
cseg segment 'CODE'
	assume cs:cseg,ds:cseg,es:cseg,ss:cseg
	org	100h
entry:
	jmp	start
hello	db 'hello',13,10
	db 'Copyright 1989 by Keith P. Graham',13,10,'$'
goodbye db 'thanks',13,10,'$'
error1 db 'Invalid file name or file not found.',13,10,'$'
error2 db 'Error Allocating Memory',13,10,'$'
error3 db 'Error Reading File',13,10,'$'
error4 db 'Error creating output file.',13,10,'$'
error5 db 'Error Writing File (disk full?)',13,10,'$'
scr_save dw 0
file1	db	65	dup(0)
file_size dw 0
file2	db	65	dup(0)
handlei dw 0
bufferi dw 0
handleo dw 0
buffero dw 0
switch1 db 0
switch2 db 0
cursor	dw 0
line_no dw 0
vbuff	dw 0
vloc	dw 0
vport	dw	3dah	; mono
fast	db 1
; vwid and vlen are the size of the current panel
vwid	dw	80
vlen	dw	25	; virtual length of page
; ux and uy are the screen cordinates of the first print area
ux	db	0
uy	db	0
; x and y are the current location?
x	db	0
y	db	0	; screen line number
curr_line dw 0	; current line number
color	db	7
line_count dw 0
;
;
;
;
;
;
list_cat:
	call	display_page ; show a page
	mov	ah,0
	int	16h	; wait for key
	ret
;
;
;
display_page:
; top_line has the starting page number
; vlen has the lines per page
; ux has the upper left hand corner of page
	mov	al,ux
	mov	x,al
	mov	al,uy
	mov	y,al
	mov	ax,curr_line
	mov	line_no,ax
	mov	cx,vlen
;
dp_loop:
	push	cx
	call	display_line
	pop	cx
	jc	blank_loop
	inc	y
	inc	line_no
	loop	dp_loop
	ret
;
;
;
;
blank_loop:
	push	cx
	mov	cx,80
	mov	dl,cs:x
	mov	dh,cs:y
	call	do_slines
	inc	y
	inc	line_no
	pop	cx
	loop	blank_loop
	ret
display_line:
; this displays a line at a location
; location is in x,y
; length is in vwid
; line number is in line_no
;
	push	ds
	push	es
;	setup	the cursor
	mov	dl,x
	mov	dh,y
; now print the line
; dx will have the current location
	mov	cx,vwid
	mov	bx,line_no
	shl	bx,1
	shl	bx,1
	mov	es,buffero
	lds	si,dword ptr es:[bx]
pline_loop:
; set up for line action
	push	cx
	mov	ah,2 ; locate cursor
	mov	bx,0
	int10h
	mov	ah,9	; print at cursor ?
	mov	cx,1
	mov	bh,00
	mov	bl,cs:color
	cld
	lodsb
	cmp	al,13
	je	sline_loop
	int10h
	inc	dl
	pop	cx
	loop	pline_loop
	jmp	done_lines
sline_loop:
; print spaces
	pop	cx
	call	do_slines
done_lines:
	clc
done_linesx:
	pop	es
	pop	ds
	ret
do_slines:
; cx has the remaining bytes to print
	mov	ah,2 ; locate cursor
	mov	bx,0
	int10h
	mov	ah,9	; print at cursor ?
	mov	bh,00
	mov	bl,cs:color
	mov	al,20h
	int10h
	ret
;
;
;
;
;
;
start:
	print hello
	call	parse_line
	jc	error_exit
	call	open_file
	jc	error_exit
;	call	create_file
;	jc	error_exit
	call	memory_alloc
	jc	error_exit
	call	save_screen
	call	read_file
	jc	error_exit
	cmp	ax,0
	je	good_exit
	mov	cx,ax
	call	setup_cat
	mov	line_no,0
	call	list_cat
good_exit:
	lea	dx,goodbye
	clc
error_exit:
	call	restore_screen
	mov	ax,cs
	mov	ds,ax
	mov	ah,9
	int	21h
	int	20h
;
;
write_file:
; get the file into memory
; cx has the size of file to write
	push	ds
	mov	bx,handleo
	mov	dx,0
	mov	ds,bufferi
	mov	ah,40h
	int	21h
	pop	ds
	jc	bad_write
	cmp	ax,cx
	je	good_write
bad_write:
	lea dx,error5
	stc
	ret
good_write:
	clc
	ret
;
;
create_file:
	mov	ax,3c00h
	mov	cx,0
	lea	dx,file2
	int	21h
	jnc	good_create
	lea	dx,error4
	stc
	ret
good_create:
	mov	handleo,ax
	clc
	ret
;
read_file:
; get the file into memory
	push	ds
	mov	bx,handlei
	mov	dx,0
	mov	cx,0ffffh
	mov	ds,bufferi
	mov	ah,3fh
	int	21h
	pop	ds
	jnc	good_read
bad_read:
	lea dx,error3
	stc
	ret
good_read:
	mov	file_size,ax
	clc
	ret
open_file:
; opens the file for reading
	mov	ax,3d10h
	lea	dx,file1
	int	21h
	jnc	good_open
	lea	dx,error1
	stc
	ret
good_open:
	mov	handlei,ax
	clc
	ret
save_screen:
; save the display
	mov	ah,3 ; get cursor
	mov	bx,0
	mov	cx,0
	int 10h
	mov	cursor,dx
; get current screen
	mov	ah,15
	int 10h
	mov	bx,0b800h
	cmp	al,7	; mono
	jne	got_col
	mov	bh,0b0h
	mov	vport,3bah
got_col:
	mov	vbuff,bx
	push	ds
	push	es
	mov	es,scr_save
	mov	si,0
	mov	ds,bx
	mov	di,0
	cld
	mov	cx,2000
rep	movsw
	pop	es
	pop	ds
	ret
restore_screen:
	jnc	rs_0
	ret
rs_0:
	push dx
	mov	dx,cursor
	mov	ah,2 ; get cursor
	mov	bx,0
	mov	cx,0
	int 10h
; save the display
; get current screen
	mov	bx,vbuff
	push	ds
	push	es
	mov	di,0
	mov	ds,scr_save
	mov	es,bx
	mov	si,0
	cld
	mov	cx,2000
rep	movsw
	pop	es
	pop	ds
	pop	dx
	ret
setup_cat:
; starts setting up cat data
	mov	si,0
	mov	di,si
	push	ds
	push	es
	mov	es,buffero
	mov	ds,bufferi
	mov	dx,ds
	jmp	sc_newline
sc_loop:
	lodsb
	cmp	al,10
	jne	sc_end_loop
sc_newline:
	mov	ax,si
	stosw
	mov	ax,dx
	stosw
sc_end_loop:
	loop	sc_loop
	pop	es
	pop	ds
	ret
;
;
do_int10h:
; this is done only if we are going fast
	push	ax
	push	cx
	push	dx
	push	di
	push	ds
        push    es
        push    cs
        pop     ds
	cmp	ah,2
	je	do_loc10
	cmp	ah,9
	je	do_10func9
	int 10h
	pop	es
        pop     ds
	pop	di
	pop	dx
	pop	cx
	pop	ax
	ret
do_10func9:
; here we put someone in the position
; character is in al, attrib in bl
        push    ax
        push    bx
        push    cx
	mov	di,vloc
	mov	ch,bl
	mov	cl,al
	mov	es,vbuff
	mov	dx,vport
c_wait1:
	in	al,dx
	test	al,1
	jnz	c_wait1
	cli
c_wait2:
	in	al,dx
	test	al,1
	jz	c_wait2
	mov	word ptr es:[di],cx
c_wait3:
 	in	al,dx
 	test	al,1
 	jnz	c_wait3
 	cli
c_wait4:
 	in	al,dx
 	test	al,1
 	jnz	c_wait4
 	mov	byte ptr es:[di+1],ch
	sti
        pop     cx
        pop     bx
        pop     ax
        inc     vloc
        loop    do_10func9
	pop	es
        pop     ds
	pop	di
	pop	dx
	pop	cx
	pop	ax
	ret
do_loc10:
; dh:dl has the,row column
	mov	al,dh
	mov	cl,80
	mul	cl
	mov	dh,0
	add	ax,dx
	shl	ax,1
	mov	vloc,ax
	pop	es
        pop     ds
	pop	di
	pop	dx
	pop	cx
	pop	ax
	ret
scrollup:
; scrolls up one line
	mov	ah,6
	mov	al,1
	mov	cx,100h
	mov	dx,174fh
	mov	bh,color
	int 10h
	ret
scrolldn:
; scrolls down one line
	mov	ah,7
	mov	al,1
	mov	cx,100h
	mov	dx,174fh
	mov	bh,color
	int 10h
	ret



;
last_byte equ this word
parse_line:
; strategy is you have to scan for switches
; then you look for an infile and an outfile
;
	mov	cl,byte ptr ds:[80h]
	mov	ch,0
	mov	di,81h
	mov	bx,0
	cld
pl0:
	mov	al,'/'
repne scasb
	jne	pl2
	mov	byte ptr ds:[di-1],20h
	mov	al,byte ptr ds:[di]
	mov	byte ptr ds:[di],20h
	or	al,32
	mov	switch1[bx],al
	inc	bx
	cmp	cx,0
	jle	pl2
	jmp	pl0
pl2:
	mov	si,81h
	lea	di,file1
	mov	cl,byte ptr ds:[80h]
	mov	ch,0
	cmp	cx,3
	jge	ok_fname
bad_fname:
	lea dx,error1
	stc
	ret
ok_fname:
; set up file
	lodsb
	cmp	al,13
	je	bad_fname
	cmp	al,20h
	je	ok_fname
	cmp	al,9
	je	ok_fname
parse1:
	stosb
	lodsb
	cmp	al,13
	je	parse2
	cmp	al,20h
	je	parse2
	cmp	al,9
	jne	parse1
parse2:
	mov	ax,0
	stosw
	clc
	ret
	lea	di,file2
parse3:
	lodsb
	cmp	al,13
	je	bad_fname
	cmp	al,20h
	je	parse3
	cmp	al,9
	je	parse3
parse4:
	stosb
	lodsb
	cmp	al,13
	je	parse5
	cmp	al,20h
	je	parse5
	cmp	al,9
	jne	parse4
parse5:
	mov	ax,0
	stosw
	clc
	ret
;
memory_alloc:
; allocates memory
; shrink
;
	mov	cx,0
	lea	ax,last_byte+512
	add	ax,15
	shr	ax,1
	shr	ax,1
	shr	ax,1
	shr	ax,1
	mov	bx,ds
	add	bx,ax
	mov	ax,4a00h
	int	21h
	jnc	good_shrink
bad_mem:
	lea dx,error2
	stc
	ret
good_shrink:
; allocate stack
	mov	ah,48h
	mov	bx,100h ; 256*16 = 4096
	int	21h
	jc	bad_mem
	pop	bx
	mov	ss,ax
	mov	sp,4094
	push bx
; allocate 64k buffer for file access
	mov	ah,48h
	mov	bx,1000h ; 64k for file reading
	int	21h
	jc	bad_mem
	mov	es:bufferi,ax
	mov	ah,48h
	mov	bx,1000h ; 64k for file reading
	int	21h
	jc	bad_mem
	mov	es:buffero,ax
	mov	ah,48h
	mov	bx,100h ; 4k for file reading
	int	21h
	jc	bad_mem
	mov	es:scr_save,ax
	clc
	ret
cseg ends
	end entry
istack	db 'HYPE-TEXT text processor',13,10
	db 'Copyright 1988 by Keith P. Graham',13,10,'$'
	db 200 dup(0)	; total length 270
error1 db 'Invalid file name or file not found.',13,10,'$'
error2 db 'Error Allocating Memory',13,10,'$'
error3 db 'Error Reading File',13,10,'$'
infile	db 64 dup(0)
scr_save dw 25*80 dup(0)
handle	dw 0
buffer	dw 0
lines	dw 0
file_size dw 0
line_no	dw	0
tline_loop: ;this is for processing the tilde line we have found
; on entry ds:si points to begining of line
	push	cs
	pop	es	; set up some addressability to data
tl_loop0:
	lodsb
	cmp	al,13
	jne	tl_1
	clc
	ret
tl_1:
	cmp	al,'~'
	je	tl_t
tl_l:
	loop	tl_loop0
	clc
	ret
tl_t:
	lodsb
	cmp	al,13
	jne	tl_2
	clc
	ret
tl_2:
	or	al,60h
; have the first byte after the tilde. It can be a P for panel
; it can be a B for button or a W for window size
;
	cmp	al,'b'
	jne	tl_nb
	stc
	ret	; with carry for end of current panel
tl_nb:
; check for window
	cmp	al,'w'
	jne	tl_wb
; have the window
	lodsb
	cmp	al,'{'
	jne	tl_t
	call	get_box
tl_wb:
	clc
	ret
get_box:
; loads in the box coordinates
	mov	bx,0
	mov	cx,10
	lodsb
	cmp	al,','
;	je
start:
	lea	sp,istack+268
	call save_screen	; saves entire screen
	call parse_line	; gets filename off of command line
	jnc	cont_0
	jmp	end_prog
cont_0:
	call open_file	; opens input file
	jnc	cont_1
	jmp	end_prog
cont_1:
	call	memory_alloc ; shrinks and allocates the file buffer
	jnc	cont_2
	jmp	end_prog
cont_2:
	call	read_file	; reads file (up to 64k) into buffer
	jnc	cont_3
	jmp	end_prog
cont_3:
	call	set_lines	; sets up the linked list of lines
;
	mov	curr_line,0	; start at top
	call	restore_screen	; retore the screen and exit
	int 20h
pgdn:
	mov	ax,vlen
	add	curr_line,ax
	jmp	check_line
pgup:
	mov	ax,vlen
	sub	curr_line,ax
	jmp	check_line
home:
	mov	curr_line,0
	jmp	dloop
endk:
	mov	ax,line_count
	sub	ax,vlen
	mov	curr_line,ax
	jmp	check_line
check_line:
; checks the line number for validity
	cmp	curr_line,0
	jl	home
	mov	ax,line_count
	sub	ax,vlen
	cmp	curr_line,ax
	jg	endk
	jmp	dloop
set_lines:
; this passes the data setting up lines
	mov	line_count,0
	push ds
	push es
	mov	cx,file_size
	mov	es,buffer
	mov	di,0
	mov	bx,4
	mov	ds,lines
	mov	word ptr ds:[0],0
	mov	word ptr ds:[2],es
	mov	di,0
	mov	al,10
	cld
look_10:
repne scasb
	jne	end_set_lines
	mov	ds:[bx],di
	mov	ds:[bx+2],es
	inc	cs:line_count
	add	bx,4
	jmp	look_10
end_set_lines:
	mov	word ptr ds:[bx],0
	mov	word ptr ds:[bx+2],0
	mov	word ptr ds:[bx-2],0
	mov	word ptr ds:[bx-4],0
	pop	es
	pop	ds
	ret
read_file:
; get the file into memory
	push	ds
	mov	bx,handle
	mov	dx,0
	mov	cx,0ffffh
	mov	ds,buffer
	mov	ah,3fh
	int	21h
	pop	ds
	jnc	good_read
bad_read:
	print error3
	stc
	ret
good_read:
	cmp	ax,0
	je	bad_read
	mov	file_size,ax
	clc
	ret
memory_alloc:
; allocates memory
; shrink
;
	mov	ah,4ah
	lea	bx,last_byte
	add	bx,15
	shr	bx,1
	shr	bx,1
	shr	bx,1
	shr	bx,1
	int	21h
	jnc	good_shrink
bad_mem:
	print error2
	stc
	ret
good_shrink:
; allocate 64k buffer for file access
	mov	ah,48h
	mov	bx,1000h ; 64k
	int	21h
	jc	bad_mem
	mov	buffer,ax
; allocate the line list
	mov	ah,48h
	mov	bx,800h ; 32k	; 8000 lines
	int	21h
	jc	bad_mem
	mov	lines,ax
; clean out the line buffer
	mov	ax,0
	push	es
	mov	cx,8000h/2
	cld
	mov	es,lines
	mov	di,0
rep	stosw
	pop	es
	clc
	ret
open_file:
; opens the file for reading
	mov	ax,3d10h
	lea	dx,infile
	int	21h
	jnc	good_open
	print error1
	stc
	ret
good_open:
	mov	handle,ax
	ret
parse_line:
	mov	cl,byte ptr ds:[80h]
	mov	ch,0
	cmp	cx,2
	jge	ok_pcx
bad_pcx:
	print error1
	stc
	ret
ok_pcx:
; set up file
	mov	di,81h
	cld
	mov	al,20h
repe scasb
	je	bad_pcx
	cmp	cx,0
	jle	bad_pcx
	mov	si,di
	dec	si
	inc	cx
	lea	di,infile
pc_1:
	lodsb
	cmp	al,13
	je	pc_2
	cmp	al,20h
	je	pc_2
	stosb
	loop	pc_1
pc_2:
	clc
	ret
last_byte equ this byte
cseg ends
	end entry
