
passthru = 1  ; 1 is true which means MASM will create the passthroug
              ; version.
; if you are making a passthroug version then rou are not making
; a resident version. And if you are not making a passthrough then
; you are making a resident.
;
if passthru
   resident = 0
else
   resident = 1
endif
CSEG        SEGMENT PARA PUBLIC 'CODE'
        ASSUME CS:CSEG,DS:CSEG,SS:CSEG,ES:CSEG
        ORG        100H
ENTPT:        JMP        setpass
; this area is used by the resident and passthrough versions
;
        db  'Next 4 bytes are scan1,shift1,scan2,shift2:'
istack   dw   512  dup(0)
savesp   dw  0
savess   dw  0
savespl  dw  0
savessl  dw  0
semaphore db  0
return   db 0
return1  db 0
mess1    db  "CRITDOG Done,  "
retc     db  "     return code",13,10,10,'$'
ints     dw   64 dup(0)

;
; this data is used by the passthru program only
;
if passthru
command_line db 129 dup(0)
; parmblock is used for the parmeters for the execute
parmblock  dw  0  ; this is the parmblock for execute
           dw command_line
tailds     dw  0
           dw 5ch ; fcb in psp
fcb1       dw  0
           dw 6ch ; fcb in psp
fcb2       dw  0
times   db  -2
int20      dd  0
int20ip   equ word ptr int20
int20cs   equ word ptr int20 + 2
int21      dd  0
int21ip   equ word ptr int21
int21cs   equ word ptr int21 + 2
int24      dd  0
int24ip   equ word ptr int24
int24cs   equ word ptr int24 + 2
int27      dd  0
int27ip   equ word ptr int27
int27cs   equ word ptr int27 + 2
endif
START        PROC        NEAR
int_20:
        mov  cs:times,1
        jmp  cs:int20
int_27:
        mov  cs:times,1
        jmp  cs:int27
crit_err:
; this is the routine for processing the critial error
        mov   al,2  ; abort
        mov  cs:return,2
        iret
old_24:
        jmp   cs:int24
dos_int:
; if the exec function is called we have to reset int 24h
      cmp   ah,4bh
      jne   try_0
      mov   cs:times,0
      jmp   cs:int21
try_0:
      cmp   ah,0
      jne   try_31
      mov   cs:times,0
      jmp   cs:int21
try_31:
      cmp   ah,31h ; exit with error code
      jne   try_4c
      mov   cs:times,0
      cmp   al,0
      je    no_nreturn
      mov   cs:return1,al
no_nreturn:
      jmp   cs:int21
try_4c:
      cmp   ah,4ch ; exit and remain resident?
      jne   try_25
      mov   cs:times,0
      cmp   al,0
      je    no_nreturn2
      mov   cs:return1,al
no_nreturn2:
      jmp   cs:int21
;
; whenever we execute a program we have to reset the count for reset
; of 2524h
try_25:
; this is a lookout for the crit err loader
      cmp   ax,2524h    ; check for set interrupt
      je    got_25h
go_normal:
      jmp   cs:int21
got_25h:
      inc   cs:times
      cmp   cs:times,3
      jge   go_normal
; have a new reset, dx has the ip and ds has the cs
;
; made it
        mov   cs:int24cs,ds
        mov   cs:int24ip,dx
      push  ax
      push  dx
      push  ds
      push  es
; set up int 24h
      mov   ax,cs
      mov   ds,ax
      mov   es,ax
;
        mov   ah,25h
        mov   al,24h
        lea   dx,crit_err
        pushf
        call  cs:int21
;
;
; now clean up the istack
        pop   es
        pop   ds
        pop   dx
        pop   ax
        iret
;
START        ENDP
setpass  proc  near
; set up a local istack
        lea  sp,istack+1022
; save interrupts
          push  ds
          mov   ax,0
          mov   si,0
          lea   di,ints
          mov   cx,62
          mov   ds,ax
          cld
rep       movsw
          pop   ds


;
; redirect interrupts here
;
        push  es
        mov   ax,3520h
        int   21h
        mov   int20cs,es
        mov   int20ip,bx
        pop   es
        mov   ah,25h
        mov   al,20h
        lea   dx,int_20
        int   21h
;
        push  es
        mov   ax,3527h
        int   21h
        mov   int27cs,es
        mov   int27ip,bx
        pop   es
        mov   ah,25h
        mov   al,27h
        lea   dx,int_27
        int   21h
;
        push  es
        mov   ax,3521h
        int   21h
        mov   int21cs,es
        mov   int21ip,bx
        pop   es
        mov   ah,25h
        mov   al,21h
        lea   dx,dos_int
        int   21h
if  passthru
;
;  prepare for the exec function
; shrink memory
   lea   bx,last_byte    ; last byte of program
   add   bx,15           ; trick to round up
   mov   cl,4
   shr   bx,cl           ; divide by 16 to get number of 16 byte blocks
   mov   ah,4ah          ; shrink
   int   21h
; create the commandline
;
; the command line has to start with /C and then the command
; and then end with a carriage return. It must have a byte at
; the front saying how long it is
   cld
   lea   di,command_line+1
   mov   al,'/'
   stosb
   mov   al,'C'
   stosb
   mov   al,' '
   stosb
; now copy the real command line in
   mov   si,81h
   mov   cl,byte ptr ds:[80h]
   mov   ch,0
   push  cx
   cmp   cx,0
   je    no_move
   cld
rep movsb
no_move:
   pop   cx
   add   cx,3
   mov   command_line,cl
; set up the control block with segment information
   mov    tailds,ds
   mov    fcb1,ds
   mov    fcb2,ds
;
; find the comspec
;
   mov    es,word ptr  ds:[2ch]
   mov     di,0
   mov     cx,255
env_loop:
   cld
   mov   al,'='
repne   scasb
; if there is no comspec, there is something wrong with the system
   cmp   word ptr es:[di-3],'CE'
   jne   env_loop
   cmp   word ptr es:[di-5],'PS'
   jne   env_loop
   cmp   word ptr es:[di-7],'MO'
   jne   env_loop
   cmp   byte ptr es:[di-8],'C'
   jne   env_loop
; got the comspec
;
; save the istack
;
   mov   savess,ss
   mov   savesp,sp
;
; set up the segment registers
;
; the comspec segment is in ES and should be in DS
;
   push  es
   pop   ds
   push  cs
   pop   es
   mov   dx,di
   lea   bx,parmblock
   mov   al,0
   mov   ah,4bh
; execute the thing
   int   21h
; here is where we return
   mov   ss,cs:savess
   mov   sp,cs:savesp
   mov   ax,cs
   mov   ds,ax
   mov   es,ax
;
; now reset the interrupts so we can leave
;
          push  es
          mov   ax,0
          mov   di,0
          lea   si,ints
          mov   cx,62
          mov   es,ax
          cld
          cli
rep       movsw
          pop   es
         mov   al,20h
         out   20h,al
        sti   ; enable interrupts
        push  ds
        lds   dx,int21
        mov   ah,25h
        mov   al,21h
        int   21h
        pop   ds
        push  ds
        lds   dx,int20
        mov   ah,25h
        mov   al,20h
        int   21h
        pop   ds
        push  ds
        lds   dx,int27
        mov   ah,25h
        mov   al,27h
        int   21h
        pop   ds
   cmp   return,0
   je    ret_0
   mov   retc,'2'
   jmp   ret_2
ret_0:
   lea   di,retc
   mov   al,return1
   mov   return,al
   mov   cx,100
   mov   ah,0
   mov   dx,0
   div   cx
   mov   cl,10
   div   cl
   or    ax,3030h
   cld
   stosw
   mov  ax,dx
   div   cl
   or    ax,3030h
   cld
   stosw
ret_2:
; say that we did it
   lea   dx,mess1
   mov   ah,9
   int  21h
        mov   ah,4ch
        mov   al,return
        int   21h
endif
if resident
        lea   dx,setpass  ; don't make the install portion resident
        int 27h
endif
setpass  endp
    db 15 dup(0)
last_byte equ this byte
CSEG        ENDS
        END        ENTPT

