; dfix program to fix ws2000 files
.MODEL tiny
.CODE
  org 100h
top:
jmp  mainproc

; data stuff
hello db 13,10,'WS2000 Date fix',13,10,'$'
err1 db 13,10,"Memory error",13,10,'$'
err2 db 13,10,"File(s) not found",13,10,'$'
err3 db 13,10,"Error opening WS2000 file",13,10,'$'
err4 db 13,10,"Error creating temp file",13,10,'$'
crlf db 13,10,'$'
mess1 db 'Processing $'
ibuffer dw 0
obuffer dw 0
filename db 128 dup(0)
path  db 128 dup(0)
fixedfile db 128 dup(0)
tempfile  db 128 dup(0)
ihandle   dw 0
ohandle   dw 0
icount    dw 0
ocount    dw 0
iloc      dw 0
oloc      dw 0
fix1      db 'DATE&',0
fix2      db 'date&',0
fix3      db  10 dup(0)
sloc      dw  0
newdate   db 40 dup(0)
changed   db 0
m1        db 'January',0
m2        db 'February',0
m3        db 'March',0
m4        db 'April',0
m5        db 'May',0
m6        db 'June',0
m7        db 'July',0
m8 db 'August',0
m9 db 'September',0
m10 db 'October',0
m11 db 'November',0
m12 db 'December',0
months dw m1,m2,m3,m4,m5,m6,m7,m8,m9,m10,m11,m12

; DTA  must not be broken up
dta   equ this byte  ; disk transfer area used for finding files
dta equ this byte
   db  21 dup(0)  ; reserved
attrib db 0 ; attribute 0 = normal,
ftime   dw 0 ; time
;  16H-17H   file time
;       bits 00H-04H=2-sec-
;       ond increments
;      (0-29)
;      bits 05H-0AH=minutes
;       (0-59)
;      bits 0BH-0FH=hours
;       (0-23)
fdate   dw 0
;    18H-19H   file date
;     bits 00H-04H=day
;      (1-31)
;     bits 05H-08H=month
;      (1-12)
;     bits 09H-0FH=year
;      (relative to 1980)
fsize dd 0
;    1AH-1DH   file size
;    1EH-2AH   ASCIIZ filename and
;       extension
foundfile db 13 dup(0)
        db 10 dup(0)
phase   dw 0
stage dw stage0,stage1,stage2,stage3
delete_temp proc near
; just in case
     mov   ah,41h
     mov   dx,offset tempfile
     int   21h
     ret
delete_temp endp
delete_file proc near
; just in case
     mov   ah,41h
     mov   dx,offset fixedfile
     int   21h
     ret
delete_file endp
rename_file proc near
     mov  di,offset tempfile    ; new name
     mov  dx,offset fixedfile   ; current name
     mov   ah,56h
     int   21h
     ret
rename_file endp
rename_temp proc near
     mov  dx,offset tempfile    ; old name
     mov  di,offset fixedfile   ; restored name
     mov   ah,56h
     int   21h
     ret
rename_temp endp
fixfiledate proc near
;get a new date for the file (same as old date, new time + 1 sec
     mov   ax,ftime
     mov   di,ax
     and   di,1111111111100000b
     and   ax,0000000000011111b
     inc   ax
     cmp   ax,30
     jl    gtime1
     mov   ax,di
     and   di,1111100000000000b
     and   ax,0000011111100000b
     mov   cx,5
     shr   ax,cl
     inc   ax
     cmp   ax,60
     jl    gtime2
     mov   ax,di
     mov   di,0
     and   ax,1111100000000000b
     mov   cx,11
     shr   ax,cl
     inc   ax
     cmp   ax,24
     jl    gtime2
     mov   ax,0

gtime2:
     shl   ax,cl
gtime1:
     or    di,ax
good_times:
     mov   ftime,di
     mov   ah,57h
     mov   bx,ohandle
     mov   al,1 ; set
     mov   dx,fdate
     mov   cx,ftime
     int   21h
     ret
fixfiledate endp
pass_file proc near
; this reads every byte of a file and copies it to new temp file
     mov   icount,0
     mov   ocount,0
     mov   iloc,0
     mov   oloc,0
ptop:
     call  getbyte
     jc    leave_pass
     mov   bx,phase
     shl   bx,1
     call  stage[bx]
     jmp   ptop
leave_pass:
     cmp   ocount,0
     je    leave_now
     call  write_temp
leave_now:
; fix up files. no errors yet!
; fixup dates
     call   fixfiledate
     ret
pass_file endp

stage0 proc near
; no match yet on amper
     cmp   al,'&'
     jne   no_change
     mov   phase,1
     ret
no_change:
     call  putbyte
     ret
stage0 endp
stage1 proc near
; got the amper looking for percent
     cmp   al,'%'
     jne   no_change1
     mov   phase,2
     mov   sloc,0
     ret
no_change1:
     mov   al,'&'
     call  putbyte
     mov   al,'%'
     call  putbyte
     mov   phase,0
     ret
stage1 endp
stage2 proc near
     mov   bx,sloc
     mov   fix3[bx],al
     cmp   al, byte ptr fix1[bx]
     je    no_change2
     cmp   al, byte ptr fix2[bx]
     je    no_change2
; not a hit have to send out the old string
     mov   fix3[bx]+1,0
     mov   al,'&'
     call  putbyte
     mov   al,'%'
     call  putbyte
     mov   si,offset fix3
     call  put_string
     mov   phase,0
     ret
no_change2:
     inc   sloc
     cmp   sloc,5
     jge   got_date
     ret
got_date:
; put in date string (newdate)
     mov  si,offset newdate
     call  put_string
     mov   phase,0
     mov   changed,1
     ret
stage2 endp
stage3 proc near
     ret
stage3 endp
put_string proc near
ps_loop:
     cld
     lodsb
     cmp   al,0
     jne   ps_2
     ret
ps_2:
     push  si
     call  putbyte
     pop   si
     jmp   ps_loop
put_string endp
getbyte proc near
	cmp  icount,0
      jg   get_byte
      mov  iloc,0
      mov  icount,0
      call read_buff
      cmp  icount,0
      jg   get_byte
      stc
      ret
get_byte:
      push  ds
      mov   si,iloc
      mov   ds,ibuffer
      cld
      lodsb
      pop   ds
      mov   iloc,si
      dec   icount
      clc
      ret
getbyte endp

read_buff proc near
       mov   icount,0
       push  ds
       mov   dx,0
       mov   bx,ihandle
       mov   cx,32000
       mov   ds,ibuffer
       mov   ah,3fh
       int   21h
       pop   ds
       jc    rb_1
       mov    icount,ax
rb_1:
       ret
read_buff endp

putbyte proc near
      push  es
      mov   di,oloc
      mov   es,obuffer
      cld
      stosb
      pop   es
      inc   ocount
      mov   oloc,di
      cmp   ocount,32000
      ja    dump_it
      clc
      ret
dump_it:
      call  write_temp
      clc
      ret
      ret
putbyte endp

write_temp proc near
       push  ds
       mov   dx,0
       mov   bx,ohandle
       mov   cx,ocount
       mov   ds,obuffer
       mov   ah,40h
       int   21h
       pop   ds
      mov   oloc,0
      mov   ocount,0
     ret
write_temp  endp

mainproc proc near
	mov	dx,offset hello
	mov	ah,9
	int	21h
	call	parse_line
	call	shrink
        call    dosfindfirst
main_loop:
; check to see if this is a guy we should care about
      call    fixdate
      jc      next_file
; before we begin cleanup in case
        call    delete_temp
        call    wsfix
next_file:
        call    findnext
        jnc     main_loop
	mov     ax,4c00h
	int	21h
	int     20h
mainproc endp
wsfix proc near
      call    fixfilename
      mov     changed,0
; new stuff.
;   rename file to temp
      call  rename_file
; steps,
;    1 create temp file
;    2 open file for input
;    3  pass file
;    4  close both
;    5  kill first file
;    6  rename temp file
      call  create_file
      call  open_input
      call  pass_file
      call  close_input
      call  close_temp
; what to do?
      cmp   changed,1
      je    kill_old
      call  delete_file
      call  rename_temp
      ret
kill_old:
;  kill old file
     call  delete_temp
; report on it
     mov  di,offset fixedfile
     cld
     mov  al,0
     mov  cx,128
     repne scasb
     dec di
      mov   byte ptr ds:[di],'$'
      mov   dx,offset mess1
      mov   ah,9
      int   21h
      mov   dx,offset fixedfile
      mov   ah,9
      int   21h
      mov   dx,offset crlf
      mov   ah,9
      int   21h
      ret
wsfix  endp
;
fixdate proc near
; this takes the date off of the file name and puts into fixed date
        jmp    short cc_1
bad_date1:
        jmp    bad_date
cc_1:
        cmp     byte ptr foundfile,'8'
        jl      bad_date1
        cmp     byte ptr foundfile,'9'
        jg      bad_date1
        mov     cx,5
        mov     si,offset foundfile+1
cfile1:
        lodsb
        cmp     al,'0'
        jl      bad_date1
        cmp     al,'9'
        jg      bad_date1
        loop    cfile1
     mov  ax,word ptr foundfile+2 ; mm
     and  ax,0f0fh
     mov  dl,ah
     mov  cl,10
     mul  cl
     mov  dh,0
     add  ax,dx
     cmp  ax,12
     jg   bad_date
     cmp  ax,0
     jle  bad_date
     mov  si,ax
     dec  si
     shl  si,1
     mov  si,months[si]
; copy in the month
     mov  di,offset newdate
     cld
dloop:
     lodsb
     cmp  al,0
     je   fd_2
     stosb
     jmp   dloop
fd_2:
     mov   al,20h
     stosb
     mov   ax,word ptr foundfile+4
     and  ax,0f0fh
     mov  dl,ah
     mov  cl,10
     mul  cl
     mov  dh,0
     add  ax,dx
     cmp  ax,31
     jg   bad_date
     cmp  ax,0
     jle  bad_date
     mov   ax,word ptr foundfile+4
     cmp   al,'0'
     je    fd_3
     stosb
fd_3:
     xchg  al,ah
     stosb
     mov   ax,' ,'
     stosw
     mov   ax,'91'
     stosw
     mov   ax,word ptr foundfile
     stosw
     mov   al,0
     stosb
     clc
     ret
bad_date:
     stc
     ret
fixdate endp
;
open_input proc near
      mov   phase,0
      mov   dx,offset tempfile
      mov   cx,0
      mov   ax,3d00h
      int   21h
      jnc   good_open
      mov   dx,offset err3
      jmp   error_exit
good_open:
      mov   ihandle,ax
      ret
open_input endp
close_input proc near
      mov   ah,3eh
      mov   bx,ihandle
      int   21h
      ret
close_input endp
close_temp proc near
      mov   ah,3eh
      mov   bx,ohandle
      int   21h
      ret
close_temp endp
create_file proc near
      mov   dx,offset fixedfile
      mov   cx,0
      mov   ax,3c00h
      int   21h
      jnc   good_create
      mov   dx,offset err4
      jmp   error_exit
good_create:
      mov   ohandle,ax
      ret
create_file endp
dosfindfirst proc near
; this is a file spec, we have to list the file
; set dta area
	lea	dx,dta
	mov	ah,1ah
	int	21h
; find first
	lea	dx,filename
	mov	ah,4eh
	mov	cx,0
	int	21h
	jnc	got_first
	lea	dx,err2
	jmp     short error_exit
got_first:
        ret
dosfindfirst endp
fixfilename proc near
        mov di,offset fixedfile
        mov si,offset path
        cld
ff_1:
        lodsb
        cmp  al,0
        je  ff_2
        stosb
        jmp  ff_1
ff_2:
        mov   si,offset foundfile
ff_3:
        lodsb
        cmp  al,0
        je  ff_4
        stosb
        jmp  ff_3
ff_4:
        stosb
        dec   di
        ret
fixfilename endp
findnext proc near
	mov	ah,4fh
	int	21h
        ret
findnext endp
error_exit proc near
; dx points to error
	mov	ah,9
	int	21h
	mov     ax,4cffh
	int	21h
error_exit endp
last_byte db 0
parse_line proc near
	mov	ch,0
	mov	cl,byte ptr ds:[80h]
	mov	si,81h
; move in file
	cld
	lea	di,filename
	mov	bx,0
floop0:
	lodsb
	cmp	al,20h
	je	fl1
	cmp	al,13
	je	fl2
	jmp     short fl3
fl1:
	loop floop0
fl2:
	lea dx,err2
	jmp	error_exit
fl3:
	stosb
	inc	bx
fl4:
	lodsb
	cmp	al,20h
	je	fl5
	cmp	al,13
	je	fl5
	stosb
	inc	bx
	loop fl4
        mov    ax,0
        stosw
fl5:
; finished the file name, do the path
        mov  di,offset path
        mov  si,offset filename
        mov  cx,128
        cld
        rep  movsb
        mov  di,offset path
        mov  cx,128
        mov  al,0
        cld
        repnz scasb
        dec   di
        dec   di
sloop:
	cmp   byte ptr ds:[di],'\'
        je    gottaslash1
        cmp   di,offset path
        jbe   gottaslash2
        dec   di
        jmp   sloop
gottaslash1:
        inc   di
gottaslash2:
	mov   byte ptr ds:[di],0
; make the temp file
        mov    di,offset tempfile
        mov    si,offset path
        cld
tt_1:
        lodsb
        cmp   al,0
        je     tt_2
        stosb
        jmp    tt_1
tt_2:
        mov   ax,'T$'
        stosw
        mov   ax,'ME'
        stosw
        mov   ax,'$P'
        stosw
        mov   ax,0
        stosw
	ret
parse_line endp
shrink proc near
; allocate memory
	mov	bx, offset last_byte
	add	bx,15
	shr	bx,1
	shr	bx,1
	shr	bx,1
	shr	bx,1
	MOV	AH,4ah
	INT	21h
	jnc	ok_shrink
memory_error:
	lea     dx,err1
	jmp	error_exit
ok_shrink:
; allocate the IO buffers - 32k of them (16k for each)
	MOV	AH,48h
	MOV	BX,800h ; 800h*16 = 32k
	INT	21h
	jc	memory_error
	CMP	BX,800h
	JNE	memory_error
	MOV	ibuffer,AX
	MOV	AH,48h
	MOV	BX,800h ; 800h*16 = 32k
	INT	21h
	jc	memory_error
	CMP	BX,800h
	JNE	memory_error
	MOV	obuffer,AX
	ret
shrink endp

end top
