; this is the COM file version of an XMS & dos based MEM manager
;
; this is INLCUDED in ASM COM file
;
SEGMENTK  equ  16
MEM_MAX   equ  100
SEGMENTSIZE  equ 4000h

virt struc
v_seg  dw  0
v_type db  0
virt  ends
v_size  equ 3
slist   db ((mem_max*v_size) + 2) dup(0)
curr_mb  dw  0
last_mb  dw  0
tot_mem  dw  0
xms_mem  dw  0
dos_mem  dw  0
;
;
;
set_curr_mb:
      jmp   get_curr_mb
;
;
;
get_curr_mb:
; this returns a current memory block in ax
      push  bx
      push  cx
      push  dx
      push  si
      push  di
      push  bp
      push  ds
      push  es
      push  cs
      pop   ds
      mov   bx,curr_mb
      cmp   bx,tot_mem
      jb    ok_gcm1
      mov   bx,tot_mem
      dec   bx
ok_gcm1:
      mov   ax,bx
      shl   ax,1     ; this stuff mult by 3
      add   bx,ax
      mov   cl,slist[bx].v_type
      mov   ax,slist[bx].v_seg
      cmp   cl,'d'
      je    page_dos
      cmp   ax,XMS_page
      je    page_xms
      mov   xms_page,ax
      call  XMS_pageout
      call  XMS_pagein
page_xms:
      mov   ax,XMS_frame
page_dos:
      pop   es
      pop   ds
      pop   bp
      pop   di
      pop   si
      pop   dx
      pop   cx
      pop   bx
      ret
;
;
;
get_next_mb:
; this returns a memory block in ax
      inc   curr_mb
      jmp   get_curr_mb
;
memory_alloc:
; allocates memory
; shrink
;
    mov  cx,0
    lea  ax,last_byte+512
    add  ax,15
    shr  ax,1
    shr  ax,1
    shr  ax,1
    shr  ax,1
    mov  bx,ds
    add  bx,ax
    mov  ax,4a00h
    int  21h
    jnc  good_shrink
bad_mem:
    lea dx,error2
    stc
    ret
good_shrink:
; allocate stack
    mov  ah,48h
    mov  bx,200h ; 512*16 = 8192
    int  21h
    jc   bad_mem
    pop  bx
    mov  ss,ax
    mov  sp,8188
    push bx
; allocate 64k buffer for file access
    mov  ah,48h
    mov  bx,400h ; 16k for file reading
    int  21h
    jc   bad_mem
    mov  ibuffer,ax
    mov  ah,48h
    mov  bx,0a00h ; 20k for hash_segment
    int  21h
    jc   bad_mem
    mov  hash_segment,ax
; now we have to assign the buffers 8 lines per 16k buffer
    mov  cx,MEM_MAX
    lea  di,slist
    mov  dos_mem,0
    mov  tot_mem,0
    mov  xms_mem,0
;
a_loop:
    push  di
    push  cx
    mov  ah,48h
    mov  bx,400h ; 16k for each screen buffer
    int  21h
    jc   done_mem
    pop   cx
    pop   di
    mov   [di].v_seg,ax
    mov   [di].v_type,'d'
    inc   dos_mem
    inc   tot_mem
    add   di,v_size
    loop  a_loop
    push  di
    push  cx
done_mem:
    pop   cx
    pop   di
;********************************************
; now check for XMS Memory
;********************************************
    push  cx
    push  di
    cmp   switchx,'x'
    je    no_xms_memory
    call  XMS_check
    jc    no_xms_memory
; open up XMS
    call  XMS_init
    jc    no_xms_memory
; get the largest block size
    call  XMS_getblock
    mov   cx,SEGMENTK
    mov   dx,0
    div   cx
    cmp   ax,2
    jl    no_xms_memory
    pop   di
    pop   cx
; ax has the number of 16k blocks of himem
; cx has the number of 16k blocks left to be allocated
    cmp   cx,ax
    jg    xms_1
    mov   ax,cx
xms_1:
    mov   cx,ax
; cx still has how much left to us in 32k blocks
    mov   ax,SEGMENTK
    mul   cx
; ax has the K of blocks to allocate
     push  di
     call  XMS_Allocate
     pop   di
     jnc  xms_2
     push  cx
     push  di
    jmp   no_xms_memory
xms_2:
; ax has the K of blocks to allocated
    mov   cx,SEGMENTK
    mov   dx,0
    mov   ax,xms_allocated
    div   cx
    mov   cx,ax
    sub   di,v_size
    dec   dos_mem
    mov   ax,[di].v_seg
    mov   xms_frame,ax
    mov   dx,0
;
xms_loop:
    mov   [di].v_seg,dx
    mov   [di].v_type,'x'
    inc   dx
    inc   xms_mem
    inc   tot_mem
    add   di,v_size
     loop  xms_loop
     push  cx
     push  di
no_xms_memory:
    pop   di
    pop   cx
    cmp   tot_mem,10
    jb    bad_mem2
    mov   ax,tot_mem
    mov   cx,100
    mov   dx,0
    div   cx
    or    al,30h
    mov   ah,14
    int   10h
    mov   ax,dx
    mov   cx,10
    mov   dx,0
    div   cx
    or    al,30h
    mov   ah,14
    int   10h
    mov   al,dl
    or    al,30h
    mov   ah,14
    int   10h
    clc
    ret
bad_mem2:
    jmp   bad_mem


; XMS stuff
;
xversion dw 0
xrevision dw 0
XMSControl  dd 0
xms_allocated  dw 0
xms_handle    dw 0
xms_frame    dw 0
xms_old_page  dw -1
xms_page     dw -1
;
; this the data for moves  KEEP IT TOGETHER
   xlength       dw 0,0
   sourcehandle  dw 0
   sourceoffset  dw 0,0
   desthandle    dw 0
   destoffset    dw 0,0
;
;
;
XMS_check:
; sees if there is an xms driver
       mov     ax,4300h
       int     2Fh
       cmp     al,80h
       jne     NoXMSDriver
       clc
       ret
NoXMSDriver:
       stc
       ret
;
XMS_Init:
; this sets up the XMS driver stuff
  ; Get the address of the driver's control function
      push    es
      mov     ax,4310h
      int     2Fh
      mov     word ptr [XMSControl],bx        ; XMSControl is a DWORD
      mov     word ptr [XMSControl+2],es
      pop     es
  ; Get the XMS driver's version number
      mov     ah,00h
      call    [XMSControl]    ; Get XMS Version Number
      mov     xversion,ax
      mov     xrevision,bx
      cmp     dx,1
      jne     bad_xversion
      clc
      ret
bad_xversion:
      stc
      ret

XMS_getblock:
; this gets the largest block of xms memory and returns it in
; the ax register
      mov   ah,8
      call    [XMSControl]
      clc
      ret

XMS_Allocate:
; this allocates k in ax
      mov   xms_allocated,ax
      mov   dx,ax
      mov   ah,9
      call    [XMSControl]
      cmp   ax,1
      je    good_xalloc
      mov   xms_allocated,0
      stc
      ret
good_xalloc:
      mov   xms_handle,dx
      mov   ax,dx
      clc
      ret


XMS_Deallocate:
; this deallocates 16k of XMS memory, handle in AX
      cmp   xms_allocated,0
      je   good_xdealloc
      cmp   xms_mem,0
      je   good_xdealloc
      mov   dx,xms_handle
      mov   ah,0ah
      call    [XMSControl]    ; Get XMS Version Number
      cmp   ax,1
      je    good_xdealloc
      stc
      ret
good_xdealloc:
      clc
      ret

;
XMS_pagein:
; this moves data in XMS memory to real memory
; ax has the handle
      mov   ax,xms_handle
      mov   sourcehandle,ax
      mov   ax,xms_page
      mov   xms_old_page,ax
      mov   cx,segmentsize
      mul   cx
      mov   sourceoffset,ax
      mov   sourceoffset+2,dx
      mov   xlength,segmentsize
      mov   xlength+2,0
      mov   desthandle,0
      mov   word ptr destoffset,0
      mov   ax,xms_frame
      mov   word ptr destoffset+2,ax
      mov   si,offset xlength
      mov   ah,0bh
      call    [XMSControl]    ; Get XMS Version Number
      cmp   ax,1
      je    ok_pi
      int 3
ok_pi:
      ret


;
XMS_pageout:
; this moves from data from real memory to xms memory
      cmp   xms_old_page,-1
      jne   xms_po_1
      ret
xms_po_1:
      mov   ax,xms_handle
      mov   desthandle,ax
      mov   ax,xms_old_page
      mov   cx,segmentsize
      mul   cx
      mov   destoffset,ax
      mov   destoffset+2,dx
      mov   xlength,segmentsize
      mov   xlength+2,0
      mov   sourcehandle,0
      mov   sourceoffset,0
      mov   ax,xms_frame
      mov   sourceoffset+2,ax
      mov   si,offset xlength
      mov   ah,0bh
      call    [XMSControl]    ; Get XMS Version Number
      cmp   ax,1
      je    ok_po
      int 3
ok_po:
      ret

