/* this does file updates based on an in and an out file */
/* vers. 1.0 does things on file date only */

#include        <dos.h>
#include        <errno.h>
#include        <fcntl.h>
#include        <io.h>
#include        <sys\types.h>
#include        <sys\stat.h>
#include        <string.h>
#include        <stddef.h>
#include        <stdio.h>
#include        <stdlib.h>
#include        <malloc.h>
#include        <time.h>


#define         BUFFSIZE        0x100

int getpath(char *t,char *s);
int copyfile(char *,char *); 		/* source,target */
int canon(char *,char *);
int do_help(void);

unsigned sdate,stime;
unsigned tdate,ttime;


char source[128];
char target[128];

char tpath[128];
char spath[128];
struct _finddata_t SDTA;
struct _finddata_t TDTA;

char work1[128];
char work2[128];

char parm1[128] = "";
char parm2[128] = "*.*";

char date[128];

char *buffer;

int quiet       = 0;
int verify      = 0;
int help        = 0;

main(int argc,char *args[])
{
    int rc,j;
	long sh;
    int cflag;
    int st;
    char c1,c2;

    st=0;
    /* get line params */
    for(j=1;j<argc;j++)
    {
	c1=args[j][0];
	c2=args[j][1];
	if((c1 == '-') || (c1 == '/'))
	{
	    /* a switch */
	    switch(c2)
	    {
	    case 'Q':
	    case 'q':
		_strdate(date);
                if(date[4]=='1')
                  quiet=0;
                else
		 quiet=1;
		break;
	    case 'V':
	    case 'v':
		verify=1;
		break;
	    case '?':
	    case 'h':
	    case 'H':
		help=1;
		break;
	    }
	}
	else
	{
	    /* not a switch */
	    if(st == 0)
	    {
		strcpy(parm1,args[j]);
		st++;
	    }
	    else
		if(st == 1)
		{
		    strcpy(parm2,args[j]);
		    st++;
		}
		else
		    help=1;
	}
    }
    if(quiet == 0)
    {
	puts("ZIMCOPY.COM\n\n");

	//puts("\nShareware Fee of $35.00 is required for continued use");
	//puts("For more information call Keith Graham Support BBS (914) 623-0039");
    }
     /* canonize source and target */

    strcpy(source,parm1);
	strcpy(target,parm2);
    /* extract the paths from source and target */
    if(getpath(spath,source)) 		/* if there are no source files */
    {
	puts("\nsource file(s) not found\n");
	return -1;
    }
    getpath(tpath,target);

    /* allocate the buffer */
    if((buffer=malloc((size_t) 0x4000)) == NULL)
    {
	puts("\nError allocating copy buffer\n");
	return -1;
    }

    /* now the loop */

    strcat(tpath,"\\");
    strcat(spath,"\\");
    //rc=_findfirst(source,_A_NORMAL,&SDTA);
    sh=_findfirst(source,&SDTA);
	if(sh>=0) {
		rc=0;
	} else {
		rc=-1;
	}
    while(rc==0)
    {
	if ((SDTA.attrib & _A_SUBDIR) != _A_SUBDIR)
	{
	    strcpy(work1,spath);
	    strcat(work1,SDTA.name);
	    if(strrchr(target,'?') == NULL)
		strcpy(work2,target);
	    else
	    {
		strcpy(work2,tpath);
		strcat(work2,SDTA.name);
	    }
	    /* do a find first on the target file to get its date */
	    cflag=0;
	    rc=_findfirst(work2,&TDTA);
	    //rc=_findfirst(work2,_A_NORMAL,&TDTA);
	    if(rc != 0)
	    {
		/* file exists, kill it */
		remove(work2);
		cflag=1;
	    }
	    else
	    {
		/* now find the dates of the files */
		//if(SDTA.wr_date == TDTA.wr_date) /* is the same date */
		//    if(SDTA.wr_time > TDTA.wr_time) /* is the time older */
		//	TDTA.wr_date--; /* make it older to force an update */
		//if(SDTA.wr_date > TDTA.wr_date) /* is the date older */
		    cflag=1;

	    }
	    if(cflag)
	    {
		/* copy the files */
		if((rc=copyfile(work1,work2)))
		{
		    if(!quiet)
			printf("\nError %d copying %s\n\n",rc,work1);
		}
	    }
	}
	rc=_findnext(sh,&SDTA);
	if(strrchr(target,'?') == NULL)
	    rc=1;
    }
    free(buffer);
   	return 0;
}
getpath(char *t,char *s)
{
    int j;
    strcpy(t,s);
    /* have to check for a directory */
    if(strrchr(s,'?') == NULL)
    {
//	if( (_findfirst(s,_A_SUBDIR,&SDTA)) != 0)
	if( (_findfirst(s,&SDTA)) != 0)
	    return(-1);
	if ((SDTA.attrib & _A_SUBDIR) == _A_SUBDIR)
	{ 				/* a dir */
	    strcat(s,"\\*.*");
	}
    }
    for (j=strlen(t)-1;j>0;j--)
    {
	if(t[j] == '\\')
	    break;
    }
    t[j]=0;
    return(0);
}


int copyfile(char *source,char *target)
{
    int infile,outfile;
    int fok;
    unsigned int rcount,wcount;
    if(!quiet)
	printf("\nCopying %s to %s  ",source,target);
    /* open for input the source */
    if ((infile=open(source,O_BINARY|O_RDONLY)) == -1)
	return 1;
    /* create the target file */

    if ((outfile=open(target,O_RDWR|O_BINARY|O_CREAT,S_IREAD|S_IWRITE)) == -1)
    {
	close(infile);
	return 2;
    }

    /* read/write loop */
    fok=0;
    while(fok == 0)
    {
        printf(".");

	if ((rcount=read(infile,buffer,BUFFSIZE)) != BUFFSIZE)
	    fok=-1;
	if ((rcount != -1) && (rcount != 0))
	{
	    if ((wcount=write(outfile,buffer,rcount)) != rcount)
	    {
		close(infile);
		close(outfile);
		return 10;
	    }
	}
    }

    /* close all files */
    close(infile);
    //_dos_setftime(outfile,SDTA.wr_date,SDTA.wr_time);
    close(outfile);
    return 0;

}
