print macro string
lea  dx,string
mov  ah,9
int 21h
endm
dseg        SEGMENT PUBLIC 'DATA'
            ASSUME CS:cseg,DS:dseg,ES:dseg
extrn buffer:word,outbuff:word,handleg:word
;
; local only stuff used by the programs
width_bytes dw    320
height_pix  dw    6000h
;
;
;
;PCB PC paintbrush
;
PCB_count      dw      128
PCB_BEG        db      0ah,02,01
PCB_BITS_PER_PIXEL db 01
PCB_X          dw      0    ;left pos in bits
PCB_Y          dw      0    ;left y in bits
PCB_LR_X       dw      0    ; right x in bits
PCB_LR_Y       dw      0    ; right y in bits
PCB_hres       dw      640
PCB_vres       Dw      200
               db      0,0,27h
               db      0,0,27h
               db      0,0,27h
               db      0,0,27h
               db      0,0,27h
               db      0,0,27h
               db      0,0,27h
               db      0,0,27h
               db      0,0,27h
               db      0,0,27h
               db      0,0,27h
               db      0,0,27h
               db      0,0,27h
               db      0,0,27h
               db      0,0,27h
               db      0,0,27h
               db      0
PCB_NUM_PLANES db      1
PCB_WIDTH_BYTES dw     80
               db      0,0,0ddh,03
               db      56  dup(0)
;
dseg        ENDS
;
cseg        SEGMENT PUBLIC 'CODE'
            ASSUME CS:cseg,DS:dseg,ES:dseg
extrn reset_segs:near
;
;
;  LOCAL Variables
;
;
;
end_switch   db  0  ; tells if we are in end_game
pcb_write  proc  near
public pcb_write
; write out the data
;
;
       push  cx
       call   reset_segs
       pop   cx
       mov    ax,outbuff
       mov    es,ax
       mov    ax,buffer
       mov    bp,width_bytes
       mov    ds,ax
       mov    di,0
       mov    si,0
; cx has the count of line to write
pcb_loop:
       push   cx    ; save the count of line
       jmp    pcb_loop0
pcb_end_loop:
       pop    cx
       loop   pcb_loop
; di has the amout of the data to write out
       call   reset_segs
       push   ds
       mov    dx,0
       mov    ax,outbuff
       mov    cx,di
       mov    ds,ax
       call   write_file
       pop    ds
       jc     dreturn
       call   reset_segs
       clc
       ret
dreturn:
       ret
; set upt the compression loop
pcb_loop0:
       cld
       lodsb    ; prime the pump
       mov   ah,al
       mov   dx,0   ; counter
       mov   bx,320 ; bytes in a line
       dec   bx
       cmp   bx,0
       jle   done_pcb_line
pcb_loop1:
       dec   bx
       cmp   bx,0
       jl    done_pcb_line
       lodsb
       xchg  ah,al
       cmp   ah,al
       je    got_pcb_repeat
; do we have a repeat in the works
       cmp   dx,0
       jne   store_count
       push  ax
       mov   ah,0
       cmp   ax,63
       pop   ax
       jg    store_count
       jmp   store_pcb
got_pcb_repeat:
       cmp   dx,62
       jge   store_count
       inc   dx
       jmp   pcb_loop1
store_count:
       inc  dx
       or   dx,0c0h
       push ax
       mov  al,dl
       stosb
       pop  ax
       mov  dx,0
store_pcb:
       stosb
       jmp   pcb_loop1
done_pcb_line:
 ; have run out of bytes in line
; ah has not been handled
       mov   al,ah
       cmp   dx,0
       jg    repeat_pcb2
       mov   ah,0
       cmp   ax,63
       jle   store_pcb2
repeat_pcb2:
       inc  dx
       or   dl,0c0h
       push ax
       mov  al,dl
       stosb
       pop  ax
store_pcb2:
       stosb
       jmp   pcb_end_loop
pcb_write  endp

;
PCB_out      PROC    NEAR
public PCB_out
       call  reset_segs
       MOV   ax,WIDTH_bytes
       mov   pcb_width_bytes,ax
       shl   ax,1
       shl   ax,1
       shl   ax,1
       dec   ax
       mov   pcb_lr_x,ax
       MOV   ax,HEIGHT_PIX
       dec   ax
       mov   PCB_LR_y,ax

       mov   cx,PCB_count
       lea   dx,pcb_beg
       call  write_file
       ret
PCB_out    ENDP
write_file proc near
; writes out a file and returns results in ax
       push bx
       push es
       push ds
       call reset_segs
       mov  bx,handleg
       mov  ah,40h
       pop  ds
       int  21h
       jc   bad_write
       cmp  ax,cx
       jne  bad_write
       pop  es
       pop  bx
       clc
       ret
bad_write:
       pop  es
       pop  bx
       stc
       ret
write_file endp
cseg        ENDS
            END
