; this module reads the menu file
CSEG SEGMENT PARA PUBLIC 'CODE'
assume cs:CSEG,ds:CSEG,es:cseg,ss:cseg
public open_file,close_file,handle
;
extrn menu:byte
menu_length  dw  0
title_length dw 0
title_lines  dw  0
menu_lines dw 0
lines dw 25 dup(0)
hotlist  db 20 dup(0)
handle  dw 0
error_code  dw 0
public error_code
;
newmenu db 64 dup(0)
gname db 'gmenu.ini',52 dup(0)
menusize dw 0
public newmenu,gname
deskv  db 0
public deskv
;
public menu_length,title_length,lines,menu_lines
public menu_length,title_lines,hotlist
;
getkeys:
public getkeys
; find if there are hot keys
     mov   bx,0  ; number of lines
     mov   di,offset hotlist
     mov   cx,menu_lines
gk_loop:
     push  cx
     mov   ah,0
     mov   si,lines[bx]+2
; scan line for hotkey
next_lod:
     cld
     lodsb
     cmp   al,0
     je    bot_gk
     cmp   al,'&'
     jne   next_lod
     mov   ah,byte ptr ds:[si]
     cmp   ah,'a'
     jl    bot_gk
     cmp   ah,'z'
     jg    bot_gk
     sub   ah,20h
bot_gk:
     pop   cx
     mov   al,ah
     stosb
     inc   bx
     inc   bx
     loop  gk_loop
     ret
housekeep:
      mov   di,offset menu_length
      mov ax,0
      mov  cx,39
      rep  stosw
      ret
getnextmenu:
public getnextmenu
   mov  dx,offset newmenu
   call open_file
   jnc  good_open
   mov  error_code,20     ; menu open error
   stc
   ret
getmenu:
public getmenu
; open the menu file (3d?)
   mov  dx,offset gname
   call open_file
   jnc  good_open
   mov  error_code,20     ; menu open error
   stc
   ret
good_open:
   mov  dx,offset menu
   mov  bx,handle
   mov  cx,2000
   mov  ax,3f00h
   int  21h
   jnc  good_read
   call close_file
   mov  error_code,21
   stc
   ret
good_read:
   call close_file
   cmp  ax,2000
   jb   good_size
   mov  error_code,22
   stc
   ret
open_file:
; dx has the name of the file to open
   mov  ax,3d00h
   int  21h
   jnc  good_of
   stc
   ret
good_of:
   mov  handle,ax
   clc
   ret
close_file:
   push ax
   push bx
; closes handle
   mov  ax,3e00h ; close
   mov  bx,handle
   int  21h
   pop  bx
   pop  ax
   ret
good_size:
   mov   menusize,ax
   push  cx
   call  housekeep   ; cleanup variables
   mov   di,menusize
   add   di,offset menu
   mov   ax,0
   stosw
   stosw
; parse the menu item out
   mov  si,offset menu
   mov  di,si
   mov  bx,0
   pop  cx
   mov  bp,0   ; count of line items
; search through find a blank line
parse_title:
; this parces through the title
   call  find_line  ; find the first character not a space
   jc    bad_end8
   jmp  by_bad_end
bad_end8:
   mov  error_code,28
   stc
   ret
bad_end9:
   mov  error_code,29
   stc
   ret
bad_end0:
   mov  error_code,30
   stc
   ret
by_bad_end:
; now have do the title lines
   mov  dx,0     ; widest line
   mov  cx,0     ; number of title lines
   cld
   mov  lines[bx],di
   inc  bx
   inc  bx
   mov  bp,1
cont_title:
   inc  cx
   call tran_line ; transfers a single line
   jc   bad_end4
; transferred one line, al has a 10 in it
   stosb
   inc  dx
   cmp  dx,title_length
   jle  check_blankt
   mov  title_length,dx
check_blankt:
   mov  dx,0
   cmp  byte ptr ds:[si],13
   je   blank_line1
   cmp  word ptr ds:[si],'//'
   je   blank_line1
   cmp  byte ptr ds:[si],' '
   jne  cont_title
blank_line1:
   mov  title_lines,cx
   dec  title_length
   dec  title_length
   mov  al,0
   stosb
;
;
   mov  menu_lines,0
   mov  menu_length,0
top_parse:
; first find the top non_blank space
; we are here at the beginning of a menu group
;
   call find_line ; get the first non-space character
   jnc  not_end
is_end:
   cmp  bp,1
   jle  bad_end7
   jmp  end_parse
bad_end4:
   mov  error_code,24
   stc
   ret
bad_end5:
   mov  error_code,25
   stc
   ret
bad_end6:
   mov  error_code,26
   stc
   ret
bad_end7:
   mov  error_code,27
   stc
   ret
not_end:
   mov  dx,0     ; widest line
   mov  cx,0     ; number of title lines
   mov  lines[bx],di
   inc  bx
   inc  bx
   inc  bp
   cmp  bp,21
   jb   ok_count
   jmp  bad_end9
ok_count:
; this is where we do each byte of menu lines
   call tran_line ; transfers a single line
   jc   is_end
   inc  menu_lines
   cmp  dx,menu_length
   jle  by_new_w
   mov  menu_length,dx
by_new_w:
; here we have the top line of a menu, have to do the next
; few lines
   mov  al,0
   stosb
; are we at a blank line?
   cmp  byte ptr ds:[si],13
   je   bad_end2
   cmp  word ptr ds:[si],'//'
   je   bad_end2
   cmp  byte ptr ds:[si],' '
   jne  cont_lines
bad_end2:
   jmp  bad_end0
cont_lines:
; now we have to get the rest of the lines
; al has the last character of the line
   call tran_line ; transfers a single line
   jc   is_end
   mov  al,0
   stosb
   cmp  byte ptr ds:[si],' '
   je   blank_line
   cmp  byte ptr ds:[si],13
   je   blank_line
   cmp  word ptr ds:[si],'//'
   je   blank_line
   jmp  cont_lines
blank_line:
; have reached end
; have a blank line, keep going until I have a new non blank
   mov   al,0
   stosb
   jmp  top_parse
end_parse:
   dec  menu_length
   dec  menu_length
   dec  bp
   mov  menu_lines,bp
   mov  ax,0
   stosw
   stosw
   clc
   ret
exit_fl:
   dec  si
   stc
   ret
find_line:
; si and di point to the work area in the menu
   lodsw
   dec  si
   cmp  al,0
   je   exit_fl
   cmp  al,26
   je   exit_fl
   cmp  al,13
   je   not_yet
   cmp  al,10
   je   not_yet
   cmp  al,20h
   je   not_yet
   cmp  ax,'//'
   je   is_comment
   dec  si  ; si points to the non-space character
   clc
   ret
is_comment:
; go until find a 0
   lodsb
   cmp  al,0
   je   not_yet
   cmp  al,26
   je   not_yet
   cmp  al,10
   jne  is_comment
not_yet:
   jmp  find_line
;
tran_line:
; this is where we do each byte of a line
   cld
   lodsw
   dec  si
   inc  dx
   cmp  ax,'//'
   je   bypass_comment
   cmp  al,13
   je   tran_line
   cmp  al,10
   je   tran_10
   cmp  al,0
   je   tran_done
   cmp  al,26
   je   tran_done
   stosb
   jmp   tran_line
tran_done:
   stc
   ret
tran_10:
   clc
   ret
bypass_comment:
   dec  si
   call find_line
   jc   tran_done
   mov  al,10
   clc
   ret
CSEG ENDS
     end

