; adding an adaptive translate for followers
print macro string
   lea dx, string
   mov  ah,9
   int  21h
   endm
cseg segment 'CODE'
   assume cs:cseg,ds:cseg,es:cseg,ss:cseg
   org   100h
;
follownum equ 2
;
;
squeeze equ 0  ; if this is the compress program then 1 else 0
if squeeze
   nsqueeze = 0
else
   nsqueeze = 1
endif
;
node struc
  weight dw ?
  rank   db ?
  who    db ?
  parent dw ?
  child  dw ?
node ends
;
;
;
entry:
        jmp   start
;  data
;
if nsqueeze
   if follownum eq 0
     include f:unsq0.asm
   endif
   if follownum eq 1
     include f:unsq1.asm
   endif
   if follownum eq 2
     include f:unsq2.asm
   endif
   if follownum eq 3
     include f:unsq3.asm
   endif
endif
;
;
;
include f:8bits.asm
include f:8bits1.asm
include f:8bits2.asm
include f:8bits3.asm
include f:8bits4.asm
;
if follownum eq 1
include f:follow1.asm
endif
if follownum eq 2
include f:follow2.asm
endif
if follownum eq 3
include f:follow3.asm
endif
;
include f:weight.asm
;
bytes_written  dw 0
bytes_comp  dw 0,0
;
; this is the linked list for rank and weight
compress:
; ax has the number of bytes to process
   mov   cx,ax
   mov   di,0
   mov   si,di
c_loop:
   push  cx
   mov   bp,ds
   mov   ds,bufferi
;
   cld
   lodsb
   mov   ah,0
   mov   ds,bp
   if nsqueeze
       call  unsq
   endif
   push  si
   push  di
   if follownum gt 0
     call  follower  ; this translate using follower table
   endif
   mov   bx,ax
; first output the string
   inc   bx  ; get past home
   shl   bx,1
   shl   bx,1
   shl   bx,1
; bx points into the nodes table
   pop   di
   push  ax
   call  out_byte
   pop   ax
   push  di
   if    follownum gt 0
   mov   bx,last_code
   else
   mov   bx,ax
   endif
   inc   bx  ; get past home
   shl   bx,1
   shl   bx,1
   shl   bx,1
; now fix up the weight
   call  fix_weight
;
; here we have to see if the ranks need changing
   call  check_weight
   pop   di
   pop   si
;
   pop   cx
   loop  c_loop
   mov   cx,di
   ret
bad_out:
   pop   cx
   stc
   ret
;
out_tally  dw 0
out_byte:
; sends the string in ax out cx bits
   mov   al,ds:home[bx].rank
   mov   ah,0
   if  squeeze
   mov   bp,es
   mov   es,buffero
   stosb
   mov   es,bp
   endif
   mov   bx,ax
   mov   cl,ltable[bx]
   mov   ch,0
   if    squeeze
   inc   bytes_written
;     shl   bx,1
;     mov   ax,btable[bx]
      mov   cl,ltable[bx]
      mov   ch,0
      add   out_size,cx
      mov   cl,ltable1[bx]
      mov   ch,0
      add   out_size1,cx
      mov   cl,ltable2[bx]
      mov   ch,0
      add   out_size2,cx
      mov   cl,ltable3[bx]
      mov   ch,0
      add   out_size3,cx
      mov   cl,ltable4[bx]
      mov   ch,0
      add   out_size4,cx
      inc   out_tally
      cmp   out_tally,2048
      jl    ot_e
; find out what to add to bytes_written
do_counter:
      mov   out_tally,0
      push  ax
      mov   ax,out_size
      cmp   ax,out_size1
      jb    ot_1
      mov   ax,out_size1
ot_1:
      cmp   ax,out_size2
      jb    ot_2
      mov   ax,out_size2
ot_2:
      cmp   ax,out_size3
      jb    ot_3
      mov   ax,out_size3
ot_3:
      cmp   ax,out_size4
      jb    ot_4
      mov   ax,out_size4
ot_4:
      add   ax,7
      shr   ax,1
      shr   ax,1
      shr   ax,1
      inc   ax
      add   bytes_comp,ax
      adc   bytes_comp+2,0
      mov   out_size4,0
      mov   out_size3,0
      mov   out_size2,0
      mov   out_size1,0
      mov   out_size,0
      pop   ax
ot_e:
;
   endif
      mov   cl,ltable4[bx]
      mov   ch,0
 
   ret


home  node <7fffh,-1,0,0,8>
nodes dw tablesize dup(0,0,0,0,0)
last  node <-1,0,0,(tablesize*8)-8,0>
;
;
;
hello  db 'hello',13,10
    db 'Copyright 1989 by Keith P. Graham',13,10,'$'
goodbye db 'thanks',13,10
out_string db '                 ',13,10,'$'
error1 db 'Invalid file name or file not found.',13,10,'$'
error2 db 'Error Allocating Memory',13,10,'$'
error3 db 'Error Reading File',13,10,'$'
error4 db 'Error creating output file.',13,10,'$'
error5 db 'Error Writing File (disk full?)',13,10,'$'
file1     db   65  dup(0)
file_size dw 0
file2     db   65  dup(0)
handlei dw 0
bufferi dw 0
handleo dw 0
buffero dw 0
switch1 db 0
switch2 db 0
curr_bits dw 0,0
out_size  dw 0,0
out_size1 dw 0,0
out_size2 dw 0,0
out_size3 dw 0,0
out_size4 dw 0,0
start:
    print hello
    call  parse_line
    jc    error_exit
    call  open_file
    jc    error_exit
    call  create_file
    jc    error_exit
    call  memory_alloc
    jc    error_exit
    if    follownum gt 0
    call  fill_follow
    endif
    call  init_nodes
    mov   curr_bits,0
read_loop:
    call  read_file
    jc    error_exit
    cmp   ax,0
    je    good_exit
    call  compress
    call  write_file
    jc    error_exit
    jmp   read_loop
good_exit:
; now try and figure out how good our compression is
    lea   di,out_string
    if squeeze
    cmp   out_tally,0
    je    ge1
    call  do_counter
ge1:
    endif
    mov   ax,bytes_comp
    mov   dx,bytes_comp+2
    mov   cx,10000
    div   cx
    mov   cl,10
    div   cl
    or    ax,3030h
    stosw
    mov   ax,dx
    mov   dx,0
    mov   cx,100
    div   cx
    mov   cl,10
    div   cl
    or    ax,3030h
    stosw
    mov   ax,dx
    div   cl
    or    ax,3030h
    stosw
    lea   dx,goodbye
error_exit:
    mov   ax,cs
    mov   ds,ax
    mov   ah,9
    int   21h
    int   20h
init_nodes:
; this initializes nodes
   mov  ax,0
   cld
   mov  di,0
   mov  cx,tablesize
in_0:
   mov  nodes[di].weight,0
   mov  nodes[di].rank,al
   mov  nodes[di].who,al
   mov  bx,di
   mov  nodes[di].parent,bx
   add  bx,16
   mov  nodes[di].child,bx
   inc  ax
   add  di,8
   loop in_0
   ret
;
write_file:
; get the file into memory
; cx has the size of file to write
    mov   cx,bytes_written
    mov   bytes_written,0
    push  ds
    mov   bx,handleo
    mov   dx,0
    mov   ds,buffero
    mov    ah,40h
    int    21h
    pop    ds
    jc     bad_write
    cmp    ax,cx
    je     good_write
bad_write:
    lea dx,error5
    stc
    ret
good_write:
    clc
    ret
;
;
create_file:
    mov  ax,3c00h
    mov  cx,0
    lea  dx,file2
    int  21h
    jnc  good_create
    lea  dx,error4
    stc
    ret
good_create:
    mov  handleo,ax
    clc
    ret
;
read_file:
; get the file into memory
    push  ds
    mov   bx,handlei
    mov   dx,0
    mov   cx,01000h
    mov   ds,bufferi
    mov    ah,3fh
    int    21h
    pop    ds
    jnc    good_read
bad_read:
    lea dx,error3
    stc
    ret
good_read:
    mov   file_size,ax
    clc
    ret
open_file:
; opens the file for reading
    mov  ax,3d10h
    lea  dx,file1
    int  21h
    jnc  good_open
    lea  dx,error1
    stc
    ret
good_open:
    mov  handlei,ax
    clc
    ret
;
last_byte equ this word
parse_line:
; strategy is you have to scan for switches
; then you look for an infile and an outfile
;
    mov  cl,byte ptr ds:[80h]
    mov  ch,0
    mov  di,81h
    mov  bx,0
    cld
pl0:
    mov  al,'/'
repne scasb
    jne  pl2
    mov  byte ptr ds:[di-1],20h
    mov  al,byte ptr ds:[di]
    mov  byte ptr ds:[di],20h
    or   al,32
    mov  switch1[bx],al
    inc  bx
    cmp  cx,0
    jle  pl2
    jmp  pl0
pl2:
    mov  si,81h
    lea  di,file1
    mov  cl,byte ptr ds:[80h]
    mov  ch,0
    cmp  cx,3
    jge  ok_fname
bad_fname:
    lea dx,error1
    stc
    ret
ok_fname:
; set up file
    lodsb
    cmp  al,13
    je   bad_fname
    cmp  al,20h
    je   ok_fname
    cmp  al,9
    je   ok_fname
parse1:
    stosb
    lodsb
    cmp  al,13
    je   parse2
    cmp  al,20h
    je   parse2
    cmp  al,9
    jne  parse1
parse2:
    mov  ax,0
    stosw
    lea  di,file2
parse3:
    lodsb
    cmp  al,13
    je   bad_fname
    cmp  al,20h
    je   parse3
    cmp  al,9
    je   parse3
parse4:
    stosb
    lodsb
    cmp  al,13
    je   parse5
    cmp  al,20h
    je   parse5
    cmp  al,9
    jne  parse4
parse5:
    mov  ax,0
    stosw
    clc
    ret
;
memory_alloc:
; allocates memory
; shrink
;
    mov  cx,0
    lea  ax,last_byte+512
    add  ax,15
    shr  ax,1
    shr  ax,1
    shr  ax,1
    shr  ax,1
    mov  bx,ds
    add  bx,ax
    mov  ax,4a00h
    int  21h
    jnc  good_shrink
bad_mem:
    lea dx,error2
    stc
    ret
good_shrink:
; allocate 64k buffer for file access
    mov  ah,48h
    mov  bx,1000h ; 64k for file reading
    int  21h
    jc   bad_mem
    mov  es:bufferi,ax
    mov  ah,48h
    mov  bx,1000h ; 64k for file reading
    int  21h
    jc   bad_mem
    mov  es:buffero,ax
    clc
    ret
cseg ends
    end entry
