;
;
freec equ 16
;
;
which_half dw 0
init_time  dw 0
;
free_up:
     inc   init_time
     cmp   init_time,6
     jne   free_up1
     call  init_nodes
     mov   init_time,-1
     ret
free_up1:
     push  ax
     push  bx
     push  cx
     push  dx
     push  si
     push  di
     inc   which_half
     and   which_half,(256/freec)-1
     mov   ax,which_half
     mov   di,ax
     shl   di,1
     shl   di,1
     add   di,ax
     mov   cx,freec
fu_1:
     call  free_node
     add   di,(256/freec)*5
     loop  fu_1
     pop   di
     pop   si
     pop   dx
     pop   cx
     pop   bx
     pop   ax
     cmp   free,-1
     jne   free_by
     jmp   free_up1
     call  init_nodes
free_by:
     ret
;
;
free_node:
     cmp   es:[di].first,-1
     je    fu1
     push  di
     mov   di,es:[di].first
     call  free_down
     pop   di
     mov   es:[di].first,-1
fu1:
     ret
free_down:
     cmp   es:[di].first,-1
     je    fd2
     push  di
     mov   di,es:[di].first
     call  free_down
     pop   di
fd1:
     cmp   es:[di].next,-1
     je    fd2
     push  di
     mov   di,es:[di].next
     call  free_down
     pop   di
fd2:
     mov   ax,free
     mov   es:[di].next,ax
     mov   free,di
     ret
;
;
;
compress:
     cld
     call  get_byte
     jnc   cont_compress
     clc
     ret
cont_compress:
;
; al has the character to decode ; es has the node space
     mov   ah,0
     mov   di,ax
     shl   di,1    ; x 2
     shl   di,1    ; x 4
     add   di,ax   ; x 5
     mov   dx,0
     call  trace
    jnc    cont_compress
     clc
     ret
;
;
trace:
; di has the root of a problem and it is undestood that
; al matches
; have to get the next guy to see if he is involved here
    call  get_byte
    jnc   tr1
; no bytes left, get rid of current guy and scram
    call  out_code
    stc
    ret
tr1:
; al has a character, di is the current location, we need to
; trace through to see if this is a string
;
;  at this point we know we have a hit on who
;
    mov   ah,0
    cmp   es:[di].first,-1
    jne   tr3
; must add the first guy to di
    call  get_free  ; get the next free node into bx
    jnc  gf9
    jmp  store_bytes2
gf9:
    mov  es:[di].first,si
    mov  es:[si].who,al
    mov  es:[si].next,-1
    mov  es:[si].first,-1
    jmp  store_bytes
tr3:
; have a first, go to it
    mov   si,es:[di].first
    jmp   test_f
test_f:
; there is a next, follow it
    cmp   es:[si].who,al
    je    got_hit
    cmp   es:[si].next,-1
    je    no_follow
    mov   si,es:[si].next
    jmp   test_f
; got a hit
got_hit:
    inc   dx
    mov   di,si
    jmp   trace
no_follow:
; have a hit on this si
    mov   bx,si
    call  get_free  ; get the next free node into bx
    jnc   gf10
    jmp  store_bytes2
gf10:
    mov  es:[bx].next,si
;
; when we get here we have a mismatch in al and as far as we got in di
; if bx = 0ffffh then we are out of string space
    mov  es:[si].first,-1
    mov  es:[si].who,al
    mov  es:[si].next,-1
store_bytes:
; this stores the guy in di
; there was no problem with free stuff so continue as though no prob
    call  out_code
;   cmp   dx,5
;   jge   add_add
    clc
    ret
add_add:
; here we are going to add another
; node to current hit
; si points to last node added
    push  ax
    call  get_byte
    jnc   gb_12
    pop   ax
    mov   ah,0
    call  put_byte
    stc
    ret
gb_12:
    mov   ah,0
    mov   di,si
    call  get_free  ; get the next free node into si
    jnc   gf12
    push  ax
    call  free_up
;   call  init_nodes
    pop   ax
    pop   bx
     mov   bh,0
     mov   di,bx
     shl   di,1    ; x 2
     shl   di,1    ; x 4
     add   di,bx   ; x 5
     mov   dx,0
    jmp   tr1
gf12:
    mov  es:[di].first,si
    mov  es:[si].first,-1
    mov  es:[si].who,al
    mov  es:[si].next,-1
    pop   bx
     mov   bh,0
     mov   di,bx
     shl   di,1    ; x 2
     shl   di,1    ; x 4
     add   di,bx   ; x 5
     mov   dx,0
    jmp   tr1
store_bytes2:
; requires di be output, needs to init nodes in meantime
    call  out_code
    push  ax
    call  free_up
;   call  init_nodes
    pop   ax
    clc
    ret
;
out_code:
    push  ax
    push  cx
    push  dx
    mov   ax,di
    mov   dx,0
    mov   cx,5
    div   cx
    mov   dx,bitsize
    dec   dx
    and   ax,dx
    call  put_byte
    pop   dx
    pop   cx
    pop   ax
    ret
;
;
;
;
get_free:
; this grabs the next free guy from list
; gets next free into si
   mov  si,-1
   push bx
   mov  bx,free
   cmp  bx,-1
   jne  gf1
   pop  bx
   stc
   ret
gf1:
   mov  si,bx
   mov  bx,es:[si].next
   mov  free,bx
   pop  bx
   clc
   ret
;
;
;
;
init_nodes:
; output the clear charater
    mov   bits,9
    mov   bitsize,512
    push  ax
    push  di
    mov   di,0
    mov   bp,es
    mov   es,nodespace
    mov   cx,256
    mov   ax,0
in1:
    mov   es:[di].next,-1
    mov   es:[di].first,-1
    mov   es:[di].who,al
    inc   al
    add   di,5
    loop  in1
; set up the free chain
;   mov   cx,(0ffffh/5)-258
;   mov   cx,4096-257
    mov   cx,8192-257
;   mov   cx,512
;   mov   cx,2048-257
in2:
    mov   ax,di
    add   ax,5
    mov   es:[di].first,-1
    mov   es:[di].next,ax
    mov   di,ax
    loop  in2
    mov   es:[di].next,-1
    mov   es:[di].first,-1
    mov   es,bp
    mov   free,5*256
    pop   di
    mov   ax,100h
    call  put_byte
    pop   ax
    ret
;
;
put_byte:
     push   ax
     push   bx
     push   di
     cmp    ax,100h
     ja     pb_2
     add   buck2,1
     adc   buck2+2,0
;    add   buck4,7
;    adc   buck4+2,0
     jmp   pb_3
pb_2:
     inc   ax
     add   buck3,1
     adc   buck3+2,0
pb_3:
     mov   cx,bits
     cmp   ax,bitsize
     jl    pb_7
     inc   bits
     mov   cx,bits
     shl   bitsize,1
pb_7:
     add   buck4,cx
     adc   buck4+2,0
pb_8:
     mov   di,outloc
     mov   bp,es
     mov   es,buffero
     stosw
     mov  es,bp
     mov  outloc,di
     cmp  di,07ff0h
     ja   full_buff
     pop  di
     pop  bx
     pop  ax
     clc
     ret
full_buff:
     mov   cx,di
     call  write_file
     mov   outloc,0
     pop  di
     pop  bx
     pop  ax
     clc
     ret
;
; this gets the next byte out of the buffer
get_byte:
     push  bx
     push  cx
     push  si
     push  di
     mov   si,bufferloc
     cmp   si,file_size
     jb    got_byte
     call  read_file
     mov   si,bufferloc
     cmp   ax,0
     jne   got_byte
     pop   di
     pop   si
     pop   cx
     pop   bx
     stc
     ret
got_byte:
     mov   bp,ds
     mov   ds,bufferi
     lodsb
     mov   ah,0
     mov  ds,bp
     mov   bufferloc,si
     pop   di
     pop   si
     pop   cx
     pop   bx
     clc
     ret
