;
oldc = 1
;
;
nodes struc
first	dw ?
who  	db ?
nwho  	db ?
next	dw ?
dad     dw ?
nodes  ends
;
;
;
tail  dw 0
;
free_count  dw 0
last_free   dw 0
;
;
;
;
compress:
     cld
     call  get_byte
     jnc   trace0
     clc
     ret
trace0:
;
; al has the character to decode ; es has the node space
     mov   di,ax
     shl   di,1    ; x 2
     shl   di,1    ; x 4
     shl   di,1    ; x 8
; di has the root of a problem and it is undestood that
; al matches
; have to get the next guy to see if he is involved here
    cmp   free_count,512
    jb    tr00
    cmp   free,-1
    jne   tr0
    mov   bx,last_free
    cmp   es:[bx].next,0
tr00:
    call  init_nodes
tr0:
    call  get_byte
    jnc   tr1
; no bytes left, get rid of current guy and scram
    call  out_code
    stc
    ret
tr1:
    mov   dx,di  ; last hit
; have matched on PREVIOUS di, have to see if current matches
;
tr2:
;
; we have entered the next level.
;   it may be tentative. if it is then who = -1 or 0
; if who = nwho then we have to remove this node from the chain
    mov   bl,es:[di].who
    cmp   bl,es:[di].nwho
    jne   tr_0
    call  free_old_node
    jnc   add_first
    call  out_code
    jmp   trace0
tr_0:
    cmp   es:[di].first,-1
    je    add_first
    cmp   es:[di].who,al
    je    move_upf
; no hit on first, try second
    cmp   es:[di].next,-1
    je    add_next
    cmp   es:[di].nwho,al
    je    move_upn
    mov   di,es:[di].next
    jmp   tr2
move_upf:
    mov   di,es:[di].first
    jmp   tr0
move_upn:
    mov   di,es:[di].next
    jmp   tr0
add_next:
    call  out_code
   int 3
gf_x:
   mov  si,free
   mov  last_free,si
   mov  bx,es:[si].next
   mov  es:[bx].dad,-1
   mov  free,bx
   cmp  si,di
   je   gf_x
   mov  es:[di].next,si
   mov  es:[di].nwho,al
   call add_new_node
   jmp  trace0
add_first:
; ran out of matches so emit the guy in dx
    call  out_code
; this tentatively adds a first
   mov  si,free
   mov  last_free,si
; check that the free node is a free node indeed.
   mov  bx,es:[si].next
   mov  free,bx
   mov  es:[bx].dad,-1
; we have two ways of approaching this, the first way adds a truly
; free node
; this tentatively adds a first
; update the di guy. this may be in the chain
   mov  es:[di].first,si
   mov  es:[di].who,al
   mov  bl,al
   inc  bl
   mov es:[di].nwho,bl
   call add_new_node
   jmp  trace0
;
free_old_node:
   dec  free_count
; this has to free a node
;
; this is a tentative node. we have to remove it from the node chain
; dad points to previous, next points to next
;
; the .first may point to someone pointing to us
    mov   bx,es:[di].dad
    mov   si,es:[di].next
; the danget here is that we will use up an end node or the last node
    cmp   bx,-1
    je    tr_4
    mov   es:[bx].next,si
    jmp   tr_5
tr_4:
    mov   free,si
tr_5:
    cmp   si,-1
    je    tr_6
    mov   es:[si].dad,bx
    jmp   tr_7
tr_6:
    mov   tail,bx
tr_7:
    mov   es:[di].first,-1
;   mov   es:[di].next,-1
    cmp   free,-1
    jne   tr_9
tr_8:
    stc
    ret
;
tr_9:
   clc
   ret
;
add_new_node:
; si is a node that must be added.
; the di data has been updated already
; a new node will have who = 0 or who = -1
   cmp   word ptr es:[si].who,-1
   je    ann_3
; since the who is zero then have to zap the guy in first
   mov  bx,es:[si].first
   cmp  es:[bx].first,si
   je   ann_2
   cmp  es:[bx].next,si
   mov  es:[bx].next,-1
   jmp  ann_3
ann_2:
   mov  es:[bx].first,-1
ann_3:
   mov   word ptr  es:[si].who,0
   mov   es:[si].first,di
; si must be now added to end of chain
   mov  bx,tail  ; get old tail
   mov  tail,si  ; our guy is now tail
   mov  es:[bx].next,si ; point old tail to us
   mov  es:[si].dad,bx  ; point us to old tail
   mov  es:[si].next,-1 ; make next, end of road
   ret
;
;
;
;
out_code:
    push  ax
    push  cx
    push  dx
    mov   ax,dx
    mov   dx,0
    mov   cx,8
    div   cx
;   mov   dx,bitsize
;   and   ax,dx
    call  put_byte
    pop   dx
    pop   cx
    pop   ax
    ret
;
;
;
;
;
;
;
;
init_nodes:
; output the clear charater
    push  ax
    mov   ax,'C'
    int   10h
    pop   ax
    mov   bits,9
    mov   bitsize,511
    push  ax
    push  di
    mov   di,0
    mov   bp,es
    mov   es,nodespace
    mov   cx,256
    mov   ax,0
in1:
    mov   es:[di].next,-1
    mov   es:[di].first,-1
    mov   word ptr es:[di].who,1  ; makes who<>nwho
    mov   es:[di].dad,-1
    add   di,8
    loop  in1
    mov   free,di
; set up the free chain
    mov   cx,(0ffffh/8)-258
    mov   cx,4096-258
;   mov   cx,8192-257
;   mov   cx,512
;   mov   cx,2048-257
    mov   free_count,cx
    mov   bx,di
    mov   bx,-1
in2:
    mov   ax,di
    add   ax,8
    mov   es:[di].next,ax  ; contains the free chain
    mov   es:[di].first,-1
    mov   word ptr es:[di].who,-1
    mov   es:[di].dad,bx
    mov   bx,di
    mov   di,ax
    loop  in2
;   mov   di,bx
    mov   tail,di
    mov   es:[di].next,-1
    mov   es:[di].dad,bx
    mov   word ptr es:[di].who,-1
    mov   es:[di].first,-1
    mov   es,bp
    pop   di
    call  put_clear ; puts a clear character
    pop   ax
    ret
;
put_clear:
    push  ax
    push  bx
    push  di
    mov   ax,100h
     mov   cx,bits
    inc   cx
    jmp   clear
;
put_byte:
     push   ax
     push   bx
     push   di
     mov   cx,bits
     cmp    ax,100h
     ja     pb_2
     add   buck2,1
     adc   buck2+2,0
     add   buck4,9
     adc   buck4+2,0
     jmp   pb_3
pb_2:
     inc   ax
     add   buck3,1
     adc   buck3+2,0
pb_3:
     cmp   ax,bitsize
     jl    pb_7
     inc   bits
     shl   bitsize,1
     or    bitsize,1
pb_7:
     cmp    ax,100h
     jb     pb_8
     inc   cx
clear:
     add   buck4,cx
     adc   buck4+2,0
pb_8:
     mov   di,outloc
     mov   bp,es
     mov   es,buffero
     stosw
     mov  es,bp
     mov  outloc,di
     cmp  di,07ff0h
     ja   full_buff
     pop  di
     pop  bx
     pop  ax
     clc
     ret
full_buff:
     mov   cx,di
     call  write_file
     mov   outloc,0
     pop  di
     pop  bx
     pop  ax
     clc
     ret
;
; this gets the next byte out of the buffer
get_byte:
     push  bx
     push  cx
     push  si
     push  di
     mov   si,bufferloc
     cmp   si,file_size
     jb    got_byte
     call  read_file
     mov   si,bufferloc
     cmp   ax,0
     jne   got_byte
     pop   di
     pop   si
     pop   cx
     pop   bx
     stc
     ret
got_byte:
     mov   bp,ds
     mov   ds,bufferi
     lodsb
     mov   ah,0
     mov  ds,bp
     mov   bufferloc,si
     pop   di
     pop   si
     pop   cx
     pop   bx
     clc
     ret
