; adding an adaptive translate for followers
print macro string
   lea dx, string
   mov  ah,9
   int  21h
   endm
cseg segment 'CODE'
   assume cs:cseg,ds:cseg,es:cseg,ss:cseg
   org   100h
;
node struc
  next   dw ?
  where  dw ?
  who    dw ?
node ends
;
pool  equ  2047   ; length of pool bytes
look  equ  19
adder equ  12
;
;
entry:
        jmp   start
;
hello  db 'hello',13,10
    db 'Copyright 1989 by Keith P. Graham',13,10,'$'
goodbye db 13,10
        db 'Bytes read:  '
bread   db '          ',13,10
        db 'Codes writ:  '
bwrit   db '          ',13,10
        db 'Byte size:   '
bsize   db '          ',13,10
        db 'Code size:   '
csize   db '          ',13,10
        db 'Total size:  '
tcount  db '          ',13,10
        db '$'
out_string db '                 ',13,10,'$'
error1 db 'Invalid file name or file not found.',13,10,'$'
error2 db 'Error Allocating Memory',13,10,'$'
error3 db 'Error Reading File',13,10,'$'
error4 db 'Error creating output file.',13,10,'$'
error5 db 'Error Writing File (disk full?)',13,10,'$'
file1     db   65  dup(0)
file_size dw 0
file2     db   65  dup(0)
tree_space dw 0
curr_si dw 0
bufferi dw 0
curr_loc equ dword ptr curr_si
handlei dw 0
handleo dw 0
buffero dw 0
switch1 db 0
switch2 db 0
bytes_written  dw 0
curr_bytes  dw 0
free  dw 0
free_count  dw 0
buck1   dw 0,0
buck2   dw 0,0
buck3   dw 0,0
buck4   dw 0,0
;
put_code:
     cmp   dx,2
     jle   pc_5
     add   buck3,adder
     adc   buck3+2,0
     add   buck2,1
     adc   buck2+2,0
     ret
pc_5:
     add   buck4,8
     adc   buck4+2,0
     ret
;
encode:
     cmp    free,-1
     jne    ok_free
; need to free some nodes
     call   free_old_nodes
     cmp    free,-1
     jne    ok_free
     call   init_nodes
ok_free:
     mov    si,free
     mov    cx,es:[si].next
     mov    free,cx
     mov    cx,es:[bx].next
     mov    es:[bx].next,si
     mov    es:[si].next,cx
     mov    es:[si].who,ax
     mov    es:[si].where,di
     mov    bx,si
;
     cmp    es:[bx].next,-1
     jne    move_up_0
     ret
move_up_0:
; add current stuff into chain
     mov    cx,di
     sub    cx,pool ; earliest where to consider
     jnb    move_up_1
     mov    cx,0
move_up_1:
     mov    si,bx   ; keep last who
     mov    bx,es:[bx].next
     cmp    es:[bx].where,cx   ; oldest count
     jb     free_nodes
     cmp    es:[bx].who,ax
     je     got_hit
check_next:
     cmp    es:[bx].next,-1
     jne   move_up_1
     ret
got_hit:
     cmp    bp,-1
     je     check_next
; have to check length of string
     push   ax
     push   cx
     push   si
     push   di
     push   ds
     push   es
;
     mov    ax,bufferi
     mov    cx,look
     mov    si,es:[bx].where
     mov    ds,ax
     mov    es,ax
     cld
     mov    ax,cx
repe cmpsb
     sub    ax,cx
     dec    ax
     pop    es
     pop    ds
     pop    di
     pop    si
     pop    cx
     cmp    dx,ax
     jge    no_match
     mov    bp,di
     mov    dx,ax
no_match:
;
     pop    ax
     cmp    dx,look
     jl     check_next
     ret
free_nodes:
; here si points to last node
     mov     es:[si].next,-1 ; ends current chain
     mov     si,free
     mov     free,bx   ; free chain now points to us
cont_free:
     inc     free_count
     cmp     es:[bx].next,-1
     jne     free_more
     mov     es:[bx].next,si ; put old free chain to end of current
     ret
free_more:
     mov     bx,es:[bx].next
     jmp     cont_free
;
;
;
free_old_nodes:
   push  ax
   push  bx
   push  cx
   push  dx
   push  si
   push  ax
   mov   ax,'F'
   int   10h
   pop   ax
     mov    dx,di
     sub    dx,pool ; earliest where to consider
     jnb    fo_1
     mov    dx,0
fo_1:
   mov   cx,256
   mov   bx,0
fon_1:
   push  bx
fon_2:
   cmp   es:[bx].next,-1
   je    fon_3
   mov   si,bx
   mov   bx,es:[bx].next
   cmp   es:[bx].where,dx   ; oldest count
   ja    fon_2
   call  free_nodes
fon_3:
   pop   bx
   inc   bx
   inc   bx
   loop  fon_1
;
   pop   si
   pop   dx
   pop   cx
   pop   bx
   pop   ax
   ret
;
;
;
;
;
compress:
; ax has the number of bytes to process
   call  init_nodes
   push  ax
   mov   ax,'R'
   int   10h
   pop   ax
   mov   cx,ax
   push  es
   mov   es,tree_space
;
comp_loop:
   push  cx
   call  get_byte
     mov    bp,di  ; where
     mov    dx,1   ; length
   call  encode
; returns length in dx, where in bp
   pop   cx
; run out the rest of dx
   cmp   cx,dx
   jge   cl_1
   mov   dx,cx
cl_1:
   call  put_code
   cmp   dx,2  ; match on 1 byte only
   jg    run_out
   loop  comp_loop
;
   pop   es
   ret
run_out:
; have to run out the rest of cx
   sub   cx,dx
   push  cx
   mov   cx,dx
ro_1:
   push  cx
   call  get_byte
   mov   bp,-1
   mov   dx,1
   call  encode
   pop   cx
   loop  ro_1
   pop   cx
   cmp   cx,0
   jle   ro_2
   loop  comp_loop
ro_2:
;
   pop   es
   ret
;
;
get_byte:
; gets a byte and puts result in bl which is shifted right
; puts the WHERE in di
;
   push  si
   push  ds
   lds   si,curr_loc
   mov   di,si
   cld
   lodsb
   mov   bl,al
   mov   ax,word ptr ds:[si]
   mov   bh,0
   shl   bx,1
;
;
   pop   ds
   mov   curr_si,si
   pop   si
   ret
;
;
;
;
;
;
;
;
;
;
init_nodes:
; this initializes nodes
   push   ax
   push   cx
   push   di
   push   es
   mov    es,tree_space
   mov    di,0
   mov    cx,256
   mov    ax,-1
   cld
rep stosw
   mov    free,di
   mov    cx,(0fdf8h/6)
   mov    free_count,cx
   mov    bx,di
in_1:
   add    bx,6
   mov    es:[di].next,bx
   mov    di,bx
   loop   in_1
   mov    es:[di].next,-1
   pop    es
   pop    di
   pop    cx
   pop    ax
   ret
;
start:
    print hello
    call  parse_line
    jc    error_exit
    call  open_file
    jc    error_exit
    call  create_file
    jc    error_exit
    call  memory_alloc
    jc    error_exit
read_loop:
    call  read_file
    jc    error_exit
    cmp   ax,0
    je    good_exit
    call  compress
    call  write_file
;   jc    error_exit
    jmp   read_loop
good_exit:
; now try and figure out how good our compression is
    call  stats
    lea   dx,goodbye
    mov   ah,9
    int   21h
    int   20h
error_exit:
    mov   ax,cs
    mov   ds,ax
    mov   ah,9
    int   21h
    int   20h
stats:
    lea  di,bread
    mov  ax,buck1
    mov  dx,buck1+2
    call bin2hex
    lea  di,bwrit
    mov  ax,buck2
    mov  dx,buck2+2
    call bin2hex
    lea  di,csize
    mov  ax,buck3
    mov  dx,buck3+2
    add  ax,7
    adc  dx,0
    shr  dx,1
    rcr  ax,1
    shr  dx,1
    rcr  ax,1
    shr  dx,1
    rcr  ax,1
    push  ax
    push  dx
    call bin2hex
    lea  di,bsize
    mov  ax,buck4
    mov  dx,buck4+2
    add  ax,7
    adc  dx,0
    shr  dx,1
    rcr  ax,1
    shr  dx,1
    rcr  ax,1
    shr  dx,1
    rcr  ax,1
    push  ax
    push  dx
    call bin2hex
    pop   dx
    pop   ax
    pop   cx
    pop   bx
    add   ax,bx
    adc   dx,cx
    lea   di,tcount
    call bin2hex
    ret
bin2hex:
    mov   cx,10000
    div   cx
    mov   cl,10
    div   cl
    or    ax,3030h
    stosw
    mov   ax,dx
    mov   dx,0
    mov   cx,100
    div   cx
    mov   cl,10
    div   cl
    or    ax,3030h
    stosw
    mov   ax,dx
    div   cl
    or    ax,3030h
    stosw
    ret
;

write_file:
; get the file into memory
; cx has the size of file to write
    mov   cx,bytes_written
    mov   bytes_written,0
    cmp   cx,0
    je    good_write
    push  ds
    mov   bx,handleo
    mov   dx,0
    mov   ds,buffero
    mov    ah,40h
    int    21h
    pop    ds
    jc     bad_write
    cmp    ax,cx
    je     good_write
bad_write:
    lea dx,error5
    stc
    ret
good_write:
    clc
    ret
;
;
create_file:
    mov  ax,3c00h
    mov  cx,0
    lea  dx,file2
    int  21h
    jnc  good_create
    lea  dx,error4
    stc
    ret
good_create:
    mov  handleo,ax
    clc
    ret
;
read_file:
; get the file into memory
    push  ds
    mov   curr_si,0
    mov   bx,handlei
    mov   dx,0
    mov   cx,07ff0h   ; 64k at a time
    mov   ds,bufferi
    mov    ah,3fh
    int    21h
    pop    ds
    jnc    good_read
bad_read:
    lea dx,error3
    stc
    ret
good_read:
    mov   file_size,ax
    add   buck1,ax
    adc   buck1+2,0
    clc
    ret
open_file:
; opens the file for reading
    mov  ax,3d10h
    lea  dx,file1
    int  21h
    jnc  good_open
    lea  dx,error1
    stc
    ret
good_open:
    mov  handlei,ax
    clc
    ret
;
last_byte equ this word
parse_line:
; strategy is you have to scan for switches
; then you look for an infile and an outfile
;
    mov  cl,byte ptr ds:[80h]
    mov  ch,0
    mov  di,81h
    mov  bx,0
    cld
pl0:
    mov  al,'/'
repne scasb
    jne  pl2
    mov  byte ptr ds:[di-1],20h
    mov  al,byte ptr ds:[di]
    mov  byte ptr ds:[di],20h
    or   al,32
    mov  switch1[bx],al
    inc  bx
    cmp  cx,0
    jle  pl2
    jmp  pl0
pl2:
    mov  si,81h
    lea  di,file1
    mov  cl,byte ptr ds:[80h]
    mov  ch,0
    cmp  cx,3
    jge  ok_fname
bad_fname:
    lea dx,error1
    stc
    ret
ok_fname:
; set up file
    lodsb
    cmp  al,13
    je   bad_fname
    cmp  al,20h
    je   ok_fname
    cmp  al,9
    je   ok_fname
parse1:
    stosb
    lodsb
    cmp  al,13
    je   parse2
    cmp  al,20h
    je   parse2
    cmp  al,9
    jne  parse1
parse2:
    mov  ax,0
    stosw
    lea  di,file2
parse3:
    lodsb
    cmp  al,13
    je   bad_fname
    cmp  al,20h
    je   parse3
    cmp  al,9
    je   parse3
parse4:
    stosb
    lodsb
    cmp  al,13
    je   parse5
    cmp  al,20h
    je   parse5
    cmp  al,9
    jne  parse4
parse5:
    mov  ax,0
    stosw
    clc
    ret
;
memory_alloc:
; allocates memory
; shrink
;
    mov  cx,0
    lea  ax,last_byte+512
    add  ax,15
    shr  ax,1
    shr  ax,1
    shr  ax,1
    shr  ax,1
    mov  bx,ds
    add  bx,ax
    mov  ax,4a00h
    int  21h
    jnc  good_shrink
bad_mem:
    lea dx,error2
    stc
    ret
good_shrink:
; allocate stack
    mov  ah,48h
    mov  bx,100h ; 4k for file reading
    int  21h
    jc   bad_mem
    pop  bx
    mov  ss,ax
    mov  sp,4094
    push bx
; allocate 64k buffer for file access
    mov  ah,48h
    mov  bx,1000h ; 64k for file reading
    int  21h
    jc   bad_mem
    mov  bufferi,ax
    mov  ah,48h
    mov  bx,800h ; 32k for file writing
    int  21h
    jc   bad_mem
    mov  buffero,ax
    mov  ah,48h
    mov  bx,1000h ; 64k for file writing
    int  21h
    jc   bad_mem
    mov  tree_space,ax
    clc
    ret
cseg ends
    end entry
