;
print macro string
   lea  dx,string
   mov  ah,9
   int  21h
   endm
CSEG        SEGMENT PARA PUBLIC 'CODE'
        ASSUME CS:CSEG,DS:CSEG,SS:CSEG,ES:CSEG
        ORG        100H
ENTPT:        JMP        setpass
;
cright db 13,10,'WMON.COM Copyright 1992 by Keith P. Graham',13,10
       db 'Version 1.00 - January 23, 1992',13,10
       db '$'
;
stack0  dw   256  dup(0)
stackl  dw   256  dup(0)
screen  db   2000 dup(0)
;
;
; this is the critical error interrupter
int24      dd  0
int24ip   equ word ptr int24
int24cs   equ word ptr int24 + 2
; timer tick
int08     dd  0
int08ip   equ word ptr int08
int08cs   equ word ptr int08 + 2
; key wait
int28     dd  0
int28ip   equ word ptr int28
int28cs   equ word ptr int28 + 2
;
indos   equ this dword
indosip  dw  0
indoscs  dw  0
buffseg dw 0
ticks    db 0
mode     db 0
herc     db 0
txtswitch db 0
eventsw  db 0
dos_version db 0
savesp   dw  0  ; used by the load program
savess   dw  0
savespl  dw  0  ; local used by int21 4b program
savessl  dw  0
semaphore db  0
vlength  dw 0
vwidth   dw 0
interlace dw 0
vbuff    dw 0
handle   dw  0
filename db 65 dup(0)
crlf db 13,10
created dw 0

user_pid	dw	?		; User's (calling program's) PID
user_ax		dw	?		; User's AX (temporary storage)
user_sp		dw	?		; User's SP
user_ss		dw	?		;   and SS
user_cc		db	?		; User's break (control-C) check flag
;
tsr_pid	dw 0
;
;
;
;
; local only stuff used by the programs
;
;
cap_text:
; save all registers
      push  ax
; save the local stack
      cli
      mov   cs:savessl,ss
      mov   cs:savespl,sp
      mov   ax,cs
      mov   ss,ax
      lea   sp,stackl+510
      sti
      push  bx
      push  cx
      push  dx
      push  bp
      push  si
      push  di
      push  ds
      push  es
        mov   ax,cs
        mov   es,ax
        mov   ds,ax
; get the vbuff
          mov ah,15
          int 10h
         mov  mode,al
          cmp al,7
          je  do_monot
          jmp do_colort
do_monot:
; mono text
         mov  vbuff,0b000h
         jmp  cap_text1
do_colort:
; color text
         mov  vbuff,0b800h
cap_text1:
;
; this captures a screen
     mov  si,0
     mov  di,offset screen
     push ds
     mov  ds,cs:vbuff
     mov  dx,0
     mov  cx,25
tlloop:
     push cx
     mov  cx,80
tcloop:
     push  di
     cld
     lodsw
     cmp    al,byte ptr es:[di]
     je     tc_bottom
     mov    dx,1
     stosb
tc_bottom:
     pop   di
     inc   di
     loop  tcloop
     pop   cx
     loop  tlloop
     pop   ds
     mov   eventsw,dl
        pop   es
        pop   ds
        pop   di
        pop   si
        pop   bp
        pop   dx
        pop   cx
        pop   bx
; restore the stack
        mov   ss,cs:savessl
        mov   sp,cs:savespl
        pop   ax
     ret

closefile:
     mov ah,3eh
     mov  bx,handle
     int  21h
     ret
check_dos proc near
        push  bx
        push  ds
        lds   bx,cs:indos
        cmp   byte ptr ds:[bx],0
        pop   ds
        pop   bx
     ret
check_dos endp
;
;
;
;
openfile  proc near
; creates an output file
     cmp   created,1
     jne   create_file
; just open the file
     mov   ah,3dh
     mov   al,21h
     lea   dx,filename
     mov   cx,0
     int   21h
     jc    bad_open
     mov   handle,ax
     clc
     ret
create_file:
; create the file
     mov   created,1
     mov   ah,3ch
     lea   dx,filename
     mov   cx,0
     int   21h
     jc    bad_open
     mov   handle,ax
     clc
     ret
bad_open:
     stc
     ret
openfile  endp
writefile proc near
; writes out a file and returns results in ax
; cx has the number of bytes to write, dx has the location
       push bx
; seek to the beginning if the file
       mov  ah,42h
       mov  dx,0
       mov  cx,0
       mov  al,0
       mov  bx,cs:handle
       int  21h
       mov  bx,cs:handle
       mov  ah,40h
       mov   dx,offset screen
       mov   cx,2000
       int  21h
       jc   bad_write
       cmp  ax,cx
       jne  bad_write
       pop  bx
       clc
       ret
bad_write:
       pop  bx
       stc
       ret
writefile endp
;
;
crit_err  proc near
	mov	al,0			; INT 24h "ignore" flag
	cmp	cs:dos_version,3	; DOS 3.xx or better?
	jb	int_24h_exit
	mov	al,3			; Yes - return "fail" flag
	iret
int_24h_exit:
        mov     al,1   ; exit?
	iret
crit_err  endp

InTSR	PROC	near
; this routine is executed to save the break and the
; crit err
        mov     ax,cs
        mov     ds,ax
        mov    es,ax

;	mov	ax,3300h		; DOS service:
;	int	21h			;   Get break flag
;	mov	user_cc,dl		; Save user's break flag

;	mov	dl,0h
;	mov	ax,3301h		; DOS service:
;	int	21h			;   Set break flag (0 = no break check)

        push    es
 	mov	ax,3524h		; DOS service:
 	int	21h			;   Get INT 24h vector
 	mov	int24ip,bx	; Save user's critical error vector
 	mov	int24cs,es
        pop     es
 	mov	dx,offset crit_err 	; Point to our critical error handler
 	mov	ax,2524h		; DOS service:
 	int	21h			;   Set INT 24h vector

	mov	ah,51h			; DOS service:
	int	21h			;   Get Process ID
	mov	user_pid,bx		; Save user's PID

	mov	bx,cs     		; Load our Process ID
	mov	ah,50h			; DOS service:
	int	21h			;   Set PID

	ret

InTSR	ENDP


;
;	Restore DOS's state for the user's program.  Flags and vectors
;	changed by InTSR are restored.
;

OutTSR	PROC	near

        mov     ax,cs
        mov     ds,ax
        mov    es,ax

	mov	bx,user_pid		; Load user's PID
	mov	ah,50h			; DOS service:
	int	21h			;   Set Process ID


 	mov	dx,int24ip       	; Point to user's critical error
 	mov	ax,int24cs      	;   handler
 	push	ds
 	mov	ds,ax
 	mov	ax,2524h		; DOS service:
 	int	21h			;   Set INT 24h vector
 	pop	ds

;	mov	dl,user_cc		; Get user's break flag
;	mov	ax,3301h		; DOS service:
;	int	21h			;   Set break flag

	ret

OutTSR	ENDP


;
;
;
;
keywait:
; int 28 is the dos wait for keystroke interrupt and it is only
; issued while dos is getting a keystroke and its state
; is saved. This prevents dos from locking up the machine
; and allows us to use the 28
       pushf
       call   cs:int28
; here we do the lock stuff to keep everyone out while ticking
        sti
        push  ax
        mov  al,1
lock    xchg cs:semaphore,al
        test al,al
        jz   int28_check
        pop  ax
        iret
int28_return:
        mov  cs:semaphore,0
        pop  ax
        iret
int28_check:
; check to see if we are working, once every 5 ticks
        cmp  cs:eventsw,0
        je   int28_return
; we can do dos calls!!!
        call  do_event
        jmp   int28_return


timer:
       pushf
       call   cs:int08
; here we do the lock stuff to keep everyone out while ticking
        push  ax
        mov  al,1
lock    xchg cs:semaphore,al
        test al,al
        jz   int08_check
        pop  ax
        iret
int08_return:
        mov  cs:semaphore,0
        pop  ax
        iret
int08_check:
; clock tick means, check for event
        inc  cs:ticks
        cmp  cs:ticks,9
        jl   int08_return
        mov  cs:ticks,0

        cmp  cs:eventsw,0
        je   check_screen
        jmp  save_screen
check_screen:
        call cap_text
        cmp  cs:eventsw,0
        jne  save_screen
        jmp  int08_return
save_screen:
; here we are
; there is an event and we are in it, can we do anything?
;
        push  bx
        push  ds
        lds   bx,cs:indos
        cmp   byte ptr ds:[bx],0
        pop   ds
        pop   bx
        je    good_indos
        jmp  int08_return
good_indos:
; we can do dos calls!!!
        call  do_event
        jmp   int08_return
do_event:
; save all registers
      push  ax
; save the local stack
      cli
      mov   cs:savessl,ss
      mov   cs:savespl,sp
      mov   ax,cs
      mov   ss,ax
      lea   sp,stackl+510
      sti
      push  bx
      push  cx
      push  dx
      push  bp
      push  si
      push  di
      push  ds
      push  es
        mov   ax,cs
        mov   es,ax
        mov   ds,ax
; do our stuff
     mov eventsw,0
     call InTSR
; we into an event, is it a text or a PCB event?
; its a text event, do text stuff
     call openfile
     jc   leave_text2
     mov  cx,2000
     mov  dx,0
     push  ds
     mov   ds,buffseg
     call writefile
     pop   ds
leave_text2:
     call closefile
     call outTSR
        pop   es
        pop   ds
        pop   di
        pop   si
        pop   bp
        pop   dx
        pop   cx
        pop   bx
        mov   ss,cs:savessl
        mov   sp,cs:savespl
        pop   ax
        ret
;
;
;
setpass  proc  near
;check dos version
	mov	ah,30h
	int	21h
	mov	dos_version,al
	test	al,al
	jnz	gf_0
	print   err0
	int	20h
gf_0:
; get the file name
   mov  ah,19h
   int  21h
   add  al,'A'
   mov  di,offset filename
   cld
   stosb
   mov  al,':'
   stosb
   mov  al,'\'
   stosb
   mov  ah,47h
   mov  dl,0
   mov  si,di
   push di
   int   21h
   pop  di
; search for end
look_fn:
   cmp  byte ptr ds:[di],0
   je   end_fn
   inc  di
   jmp  look_fn
end_fn:
   mov  si,81h
   cld
   cmp  byte ptr ds:[di]-1,'\'
   je   gf_loop
   mov  al,'\'
   stosb
;
gf_loop:
   lodsb
   cmp  al,20h
   je   gf_loop
   cmp  al,9
   je   gf_loop
   cmp  al,13
   jne  gf_2
bad_command:
; bad command line
    print err1
    int 20h
gf_2:
    stosb
    lodsb
    cmp  al,20h
    je   gf_3
    cmp  al,9
    je   gf_3
    cmp  al,13
    jne  gf_2
    jmp  bad_command
gf_3:
   mov  di,offset command_line+1
   stosb
   mov   al,'/'
   stosb
   mov   al,'C'
   stosb
   mov   al,' '
   stosb
   mov   cx,4
gf_3a:
   lodsb
   cmp  al,20h
   je   gf_3a
   cmp  al,9
   je   gf_3a
   cmp  al,13
   je   bad_command
; now copy the real command line in
gf_4:
   stosb
   inc   cx
   lodsb
    cmp  al,13
    jne  gf_4
gf_5:
   stosb
   mov   command_line,cl
sp1:
; set up a local stack
        lea  sp,stack0+510
        print cright
        print mess0
	mov	ah,51h			; DOS service:
	int	21h			;   Get Process ID
	mov	tsr_pid,bx		; Save TSR's PID

;
; redirect interrupts here
;
; redirect 28 and timer tick
;
;
;  28 is the keywait
        push  es
        mov   ax,3528h
        int   21h
        mov   int28cs,es
        mov   int28ip,bx
        pop   es
        mov   ah,25h
        mov   al,28h
        lea   dx,keywait
        int   21h
;
;  08 is the timer tick
        push  es
        mov   ax,3508h
        int   21h
        mov   int08cs,es
        mov   int08ip,bx
        pop   es
        mov   ah,25h
        mov   al,08h
        lea   dx,timer
        int   21h
;
; get the INDOS flag
        push  es
        mov   ah,34h
        int   21h
        mov   indosip,bx
        mov   indoscs,es
        pop   es
;
;
;  prepare for the exec function
; shrink memory
   lea   bx,last_byte    ; last byte of program
   add   bx,15           ; trick to round up
   mov   cl,4
   shr   bx,cl           ; divide by 16 to get number of 16 byte blocks
   mov   ax,bx
   mov   buffseg,ds     ; segment of buffer
   mov   ah,4ah          ; shrink
   int   21h
;
; create the commandline
;
; the command line has to start with /C and then the command
; and then end with a carriage return. It must have a byte at
; the front saying how long it is
; set up the control block with segment information
   mov    tailds,ds
   mov    fcb1,ds
   mov    fcb2,ds
;
; find the comspec
;
   mov    es,word ptr  ds:[2ch]
   mov     di,0
   mov     cx,255
env_loop:
   cld
   mov   al,'='
repne   scasb
; if there is no comspec, there is something wrong with the system
   cmp   word ptr es:[di-3],'CE'
   jne   env_loop
   cmp   word ptr es:[di-5],'PS'
   jne   env_loop
   cmp   word ptr es:[di-7],'MO'
   jne   env_loop
   cmp   byte ptr es:[di-8],'C'
   jne   env_loop
; got the comspec
;
; save the stack
;
   mov   savess,ss
   mov   savesp,sp
;
; set up the segment registers
;
; the comspec segment is in ES and should be in DS
;
   push  es
   pop   ds
   push  cs
   pop   es
   mov   dx,di
   lea   bx,parmblock
   mov   al,0
   mov   ah,4bh
; execute the thing
   int   21h
; here is where we return
   mov   ss,cs:savess
   mov   sp,cs:savesp
   mov   ax,cs
   mov   ds,ax
   mov   es,ax
;
; now reset the interrupts so we can leave
;
;
        push  ds
        lds   dx,int08
        mov   ah,25h
        mov   al,08h
        int   21h
        pop   ds
;
        push  ds
        lds   dx,int28
        mov   ah,25h
        mov   al,28h
        int   21h
        pop   ds
; say that we did it
   lea   dx,mess1
   mov   ah,9
   int  21h
   int  20h
setpass  endp
;
mess0    db  "WMON installing.....",13,10,10,'$'
mess1    db  "WMON Uninstalling.....",13,10,10,'$'
command_line db 129 dup(0)
; parmblock is used for the parmeters for the execute
parmblock  dw  0  ; this is the parmblock for execute
           dw command_line
tailds     dw  0
           dw 5ch ; fcb in psp
fcb1       dw  0
           dw 6ch ; fcb in psp
fcb2       dw  0
;
err0   db 13,10,7,'Wrong DOS Version.',13,10,'$'
err1   db 13,10,7,'Form of WMON is:',13,10
       db 9,'WMON filename DOS command',13,10,'$'
last_byte db 0
CSEG        ENDS
        END        ENTPT
;
;

