registered equ 0
yuri equ 1
print macro string
  mov  ah,9
  mov  dx,offset string
  int   21h
endm
cseg segment para public 'CODE'
  assume cs:CSEG,ds:CSEG,es:CSEG,ss:CSEG
  org 100h
top:
jmp start
sav_int2f dd 0;
screen1 db 8000 dup(0)
keys    dw 512*4 dup(0)  ; 4 256 byte key buffers
head dw 0,512,1024,1536
tail dw 0,512,1024,1536
kloc dw 0,512,1024,1536,2048
cursors  dw 4 dup(0);
int2f_proc:
   cmp   ax,'KG'
   jne   next_2f
   cmp   bx,'EC'   ; returns a screen byte
   je    ret_screen1
   cmp   bx,'LA'   ; fills up a screen
   je    fill_screen
   cmp   bx,'CU'   ; returns the cursor
   je    get_cursor
   cmp   bx,'IN'   ; returns the cursor
   je    get_install
   cmp   bx,'ST'   ; push a keystroke into the stack
   jne   next_2f
   jmp   stuff_key
get_install:
   mov   si,word ptr cs:sav_int2f+2
   mov   dx,word ptr cs:sav_int2f
   mov   bx,'OK'
   iret
ret_screen1:
   jmp   ret_screen
next_2f:
   jmp  dword ptr cs:sav_int2f
get_cursor:
   push  si
   mov   si,dx
   shl   si,1
   mov   ax,cs:cursors[si]
   pop   si
   iret
fill_screen:
; this happens every tick
   push ax
   push bx
   push cx
   push si
   push di
   push ds
   push es
   mov  ax,1681h
   int  2fh
; now the cursor location
;
   push  dx
   mov  si,dx
   shl  si,1
   mov  ah,3
   mov  bx,0
   int  10h
   mov  cs:cursors[si],dx
   pop  dx

   push cs
   pop  es

   mov  ax,0b800h
   mov  ds,ax
   mov  si,0
   mov  di,offset screen1
   cmp  dx,0
   je   do_mov1
   add  di,2000
   cmp  dx,1
   je   do_mov1
   add  di,2000
   cmp  dx,2
   je   do_mov1
   add  di,2000
do_mov1:
   mov  cx,2000
do_mov:
   cld
   lodsw
   stosb
   loop  do_mov
; next step is to stuff any keys that need stuffing
do_keystroke:
   push  cs
   pop   ds
   push cx
   mov  cx,15
check_again:
   push  cx
   call check_buff
   jc   no_stuffed
   mov   si,dx
   shl   si,1
   mov   ax,head[si]
   cmp   ax,tail[si]
   je    no_stuffed
   mov   bx,ax   ; index into keys
; fix head
   inc   ax
   inc   ax
   cmp   ax,kloc[si+2]
   jl    ok_head
   mov   ax,kloc[si]
ok_head:
   mov   head[si],ax
   mov   cx,keys[bx]
; stuff the key using int 16h

   push  dx
   mov   ah,5
   int   16h
   pop  dx
   pop  cx
   loop check_again
   pop  cx
   jmp  by_stuffed
;
;  jmp   check_again
no_stuffed:
;
   pop  cx
   pop  cx
by_stuffed:
   mov  ax,1682h
   int  2fh
   pop  es
   pop  ds
   pop  di
   pop  si
   pop  cx
   pop  bx
   pop  ax
   iret
check_buff:
   push  ax
   push  es
   mov   ax,40h
   mov   es,ax
   mov  ax,word ptr es:[1ch]	; AX = tail of buffer
   INC	ax			;	...advance
   INC	ax	  		;	...by word
   CMP	AX,word ptr ES:[82h]    ; End of buffer reached?
   JNZ	KY_CHK	   		;	...no, skip
   mov  ax,word ptr es:[80h]
KY_CHK:
   CMP	ax,word ptr ES:[1Ah]	; ax = Buffer Head ?
   pop  es
   pop  ax
   JNZ	ok_buff     		;	...no, OK
   stc
   ret
ok_buff:
   clc
   ret
ret_screen:
; returns a byte at a screen location thats in cx
; from screen in dx
   push  si
   mov   si,offset screen1
   add   si,cx
   cmp  dx,0
   je   do_mov2
   add  si,2000
   cmp  dx,1
   je   do_mov2
   add  si,2000
   cmp  dx,2
   je   do_mov2
   add  si,2000
do_mov2:
   mov   al,byte ptr cs:[si]
   pop   si
   iret
stuff_key:
; this is where a keystroke gets stuffed
   push ax
   push bx
   push cx
   push si
   push di
   push ds
   push es
   push cs
   pop  ds
   mov  si,dx  ; dx has w, cx has the key
   shl  si,1
   mov  ax,tail[si]
   mov   bx,ax   ; index into keys - save for later
   inc   ax
   inc   ax
   cmp   ax,kloc[si+2]
   jl    ok_tail
   mov   ax,kloc[si]
ok_tail:
   cmp   ax,head[si]   ; overrun???
   jne   ok_tail2
; do stuff here for bad stuff
  jmp   no_tail
ok_tail2:
   mov   tail[si],ax
no_tail:
; fix head
; now cx has to be pushed into the buffer
   mov   keys[bx],cx
   pop  es
   pop  ds
   pop  di
   pop  si
   pop  cx
   pop  bx
   pop  ax
   iret
start:
print hello
; see if we are in Uninstall mode
    mov   si,81h
    mov   cl,byte ptr ds:[80h]
    mov   ch,0
    cmp   cx,0
    jle   no_loop
u_loop:
    cld
    lodsb
    cmp   al,13
    je    no_loop
    cmp   al,'u'
    je   got_u
    cmp   al,'U'
    je   got_u
    loop  u_loop
    jmp  no_loop
got_u:
; time to uninstall
    mov   ax,'KG'
    mov   bx,'IN'
    int   2fh
    cmp   bx,'OK'
    je    uninstall
    mov   dx,offset error3
    jmp   error_exit
uninstall:
; ds:dx returns in si:dx
     push  ds
     mov   ds,si
     MOV   AX,252Fh
     INT   21h
     pop   ds
     mov  dx,offset message1
     jmp  error_exit
no_loop:
; check to see if we are already loaded
    mov   ax,'KG'
    mov   bx,'IN'
    int   2fh
    cmp   bx,'OK'
    jne   doinstall
    mov   dx,offset error2
    jmp   error_exit
doinstall:
; detect windows
;    mov  ax,1600h
;    int   2fh
;    and   al,7fh
;    cmp   al,0
;    jne   bad_win
; this sets the control break, also sets int2fical error
;
; int2f_err first
;
            push  ds
            MOV   AX,352Fh
            INT   21h
            MOV   word ptr sav_int2f,BX  ;SAVE OFFSET
            MOV   word ptr sav_int2f+2,ES      ;SAVE SEGMENT
            mov   DX,offset int2f_proc
            MOV   AX,252Fh
            INT   21h
            pop   ds
            mov   dx,offset start
            int  27h
bad_win:
   mov   dx,offset error1
error_exit:
   mov   ah,9
   int   21h
   int  20h
hello db 13,10,'XRAYDOS.COM V1.1 - Native DOS Portion of XRAY Screen Capture',13,10
if registered
      db ' *********** UNREGISTERED VERSION ***********',13,10
endif
if yuri
      db 'Copyright 1994 by Integrated Business Image Solutions, Inc.',13,10
else
       db 'Copyright 1994 by Keith P. Graham',13,10
       db 'BBS (914) 623-0039',13,10,10,'$'
endif
      db 13,10,'$'
error1 db 13,10,'ERROR in XRAYDOS.COM',13,10
      db 'This Program MUST be run before Windows starts',13,10,'$'
error2 db 13,10,'ERROR in XRAYDOS.COM',13,10
      db 'XRAYDOS Already loaded',13,10,'$'
error3 db 13,10,'ERROR in XRAYDOS.COM',13,10
      db "XRAYDOS not loaded, Can't unload",13,10,'$'
message1 db 13,10,'XRAY Uninstalled',13,10,'$'
cseg ends
END top
